
////////////////////////////////////////////////
// @运行时
////////////////////////////////////////////////
if (typeof (GSApp) == "undefined")
{
    GSApp = function () { };
}

////////////////////////////////////////////////
// @XML操作类
////////////////////////////////////////////////

GSApp.XML = function () { };

////////////////////////////////////////////////
// @用户信息
////////////////////////////////////////////////

GSApp.XML.getHtmlTagNameInString = function (html)
{
    var tagName = html;
    {
        for (var charIndex = 0;
            charIndex < html.length;
            charIndex++)
        {
            var char = html.charAt(charIndex);
            if (char <= 32
                || char >= 127
                || (charIndex != 0 && char == "/")
                || char == ">")
            {
                // !!!
                tagName = html.substring(0, charIndex);
                // !!!
                break;
            }
        }
    }
    return tagName.toUpperCase();
}

GSApp.XML.HtmlNode =
{
    parent: null,
    type: "",
    text: "",
    children: []
}

/**
 * 解析Html字符串，转为：HtmlNodes对象。
 *
 * @param {string} html, 要解析的Html字符串
 * @returns {array} GSApp.XML.HtmlNode 类型数组。
 */
GSApp.XML.parseHtml = function (html)
{
    var htmlNodes = new Array();
    htmlNodes.innerText = "";
    {
        var currentHtmlNode = null;
        var currentTagNames = new Array();
        var currentTagName = null;
        var currentTagNameBeginIndex = -1;
        var currentTagInnerText = null;
        // !!!
        var currentTagInnerTextBeginIndex = 0;
        // !!!
        var currentEndTagName = null;
        var currentEndTagNameBeginIndex = -1;
        var lastCharIndex = html.length - 1;
        for (var charIndex = 0;
            charIndex < html.length;
            charIndex++)
        {
            var char = html.charAt(charIndex);
            var isLastCharIndex = charIndex == lastCharIndex;
            if (currentTagName == null)
            {
                if (char == "<"
                    || (isLastCharIndex && currentTagNameBeginIndex < 0))
                {
                    // !!!
                    var currentTagInnerTextEndIndex
                        = char == "<"
                            ? charIndex
                            : charIndex + 1;
                    if (currentTagInnerTextEndIndex > currentTagInnerTextBeginIndex)
                    {
                        currentTagInnerText = html.substring(
                            currentTagInnerTextBeginIndex,
                            currentTagInnerTextEndIndex);
                        // !!!
                        htmlNodes.innerText += currentTagInnerText;
                        {
                            var newNode =
                            {
                                parent: currentHtmlNode,
                                type: "TEXT",
                                text: currentTagInnerText
                            };
                            if (currentHtmlNode != null)
                            {
                                currentHtmlNode.children.push(newNode);
                            }
                            else
                            {
                                htmlNodes.push(newNode);
                            }
                        }
                    }
                    // !!!
                    // !!!
                    currentTagNameBeginIndex = charIndex + 1;
                }
                else if (currentTagNameBeginIndex >= 0)
                {
                    if (char == ">"
                        || isLastCharIndex)
                    {
                        var currentTagNameEndIndex
                            = char == ">"
                                ? charIndex
                                : charIndex + 1;
                        var currentTagNameLength = charIndex - currentTagNameBeginIndex;
                        if (currentTagNameLength > 0)
                        {
                            var currentTagOrignialCodes
                                = html.substring(
                                    currentTagNameBeginIndex,
                                    currentTagNameEndIndex).trim();
                            currentTagName = GSApp.XML.getHtmlTagNameInString(currentTagOrignialCodes);
                            if (currentTagName == "IMG"
                                || currentTagName == "BR")
                            {
                                if (currentTagOrignialCodes.indexOf("/") < 0)
                                {
                                    currentTagOrignialCodes += "/";
                                }
                            }
                            // !!!
                            {
                                var newHtmlNode =
                                {
                                    parent: currentHtmlNode,
                                    type: "NODE",
                                    tagName: currentTagName,
                                    tagOrignialCodes: currentTagOrignialCodes,
                                    children: new Array()
                                };
                                if (currentHtmlNode != null)
                                {
                                    currentHtmlNode.children.push(newHtmlNode);
                                }
                                else
                                {
                                    htmlNodes.push(newHtmlNode);
                                }
                                currentHtmlNode = newHtmlNode;
                            }
                            currentTagNames.push(currentTagName);
                            // !!!
                            currentTagInnerTextBeginIndex = currentTagNameEndIndex + 1;
                            // !!!
                            var indexOfSlash = currentTagOrignialCodes.indexOf("/");
                            if ((indexOfSlash >= 0
                                && (indexOfSlash + 1) == currentTagOrignialCodes.length)
                                || (currentTagName == "IMG"
                                    || currentTagName == "BR"))
                            {
                                // !!!
                                if (currentHtmlNode != null)
                                {
                                    currentHtmlNode = currentHtmlNode.parent;
                                }
                                else
                                {
                                    currentHtmlNode = null;
                                }
                                currentTagNames.pop();
                                currentTagName = null;
                                // !!!
                            }
                        }
                    }
                }
            }
            else
            {
                if (currentEndTagNameBeginIndex < 0)
                {
                    if (char == "<"
                        || isLastCharIndex)
                    {
                        // !!!
                        var currentTagInnerTextEndIndex
                            = char == "<"
                                ? charIndex
                                : charIndex + 1;
                        if (currentTagInnerTextEndIndex > currentTagInnerTextBeginIndex)
                        {
                            currentTagInnerText = html.substring(
                                currentTagInnerTextBeginIndex,
                                currentTagInnerTextEndIndex);
                            // !!!
                            htmlNodes.innerText += currentTagInnerText;
                            {
                                var newNode =
                                {
                                    parent: currentHtmlNode,
                                    type: "TEXT",
                                    text: currentTagInnerText
                                };
                                if (currentHtmlNode != null)
                                {
                                    currentHtmlNode.children.push(newNode);
                                }
                                else
                                {
                                    htmlNodes.push(newNode);
                                }
                            }
                        }
                        // !!!
                        // !!!
                        currentEndTagNameBeginIndex = charIndex + 1;
                        // !!!
                    }
                }
                else if (currentEndTagNameBeginIndex >= 0)
                {
                    if (char == ">"
                        || isLastCharIndex)
                    {
                        var currentEndTagNameEndIndex
                            = char == ">"
                                ? charIndex
                                : charIndex + 1;
                        var currentEndTagNameLength = charIndex - currentEndTagNameBeginIndex;
                        if (currentEndTagNameLength > 0)
                        {
                            var currentEndTagOrignialCodes = html.substring(
                                currentEndTagNameBeginIndex,
                                currentEndTagNameEndIndex);
                            currentEndTagName = GSApp.XML.getHtmlTagNameInString(currentEndTagOrignialCodes);
                            if (currentEndTagName == "IMG"
                                || currentEndTagName == "BR")
                            {
                                if (currentEndTagOrignialCodes.indexOf("/") < 0)
                                {
                                    currentEndTagOrignialCodes += "/";
                                }
                            }
                            // !!!
                            if (currentEndTagName == "/" + currentTagName)
                            {
                                if (currentHtmlNode != null)
                                {
                                    currentHtmlNode = currentHtmlNode.parent;
                                }
                                currentTagNames.pop();
                                if (currentTagNames.length > 0)
                                {
                                    currentTagName = currentTagNames[currentTagNames.length - 1];
                                }
                                else
                                {
                                    currentTagName = null;
                                }
                                currentTagNameBeginIndex = -1;
                                currentTagInnerText = null;
                                // !!!
                                currentTagInnerTextBeginIndex = currentEndTagNameEndIndex + 1;
                                // !!!
                                currentEndTagName = null;
                                currentEndTagNameBeginIndex = -1;
                                //
                            }
                            else
                            {
                                currentTagName = currentEndTagName;
                                currentTagNameBeginIndex = currentEndTagNameBeginIndex;
                                // !!!
                                {
                                    var newHtmlNode =
                                    {
                                        parent: currentHtmlNode,
                                        type: "NODE",
                                        tagName: currentTagName,
                                        tagOrignialCodes: currentEndTagOrignialCodes,
                                        children: new Array()
                                    };
                                    if (currentHtmlNode != null)
                                    {
                                        currentHtmlNode.children.push(newHtmlNode);
                                    }
                                    else
                                    {
                                        htmlNodes.push(newHtmlNode);
                                    }
                                    currentHtmlNode = newHtmlNode;
                                }
                                currentTagNames.push(currentTagName);
                                // !!!
                                currentTagInnerTextBeginIndex = currentEndTagNameEndIndex + 1;
                                // !!!
                                currentEndTagName = null;
                                currentEndTagNameBeginIndex = -1;
                                // !!!

                                var indexOfSlash = currentEndTagOrignialCodes.indexOf("/");
                                if ((indexOfSlash >= 0
                                    && (indexOfSlash + 1) == currentEndTagOrignialCodes.length)
                                    || (currentTagName == "IMG"
                                        || currentTagName == "BR"))
                                {
                                    // !!!
                                    if (currentHtmlNode != null)
                                    {
                                        currentHtmlNode = currentHtmlNode.parent;
                                    }
                                    else
                                    {
                                        currentHtmlNode = null;
                                    }
                                    currentTagNames.pop();
                                    if (currentTagNames.length > 0)
                                    {
                                        currentTagName = currentTagNames[currentTagNames.length - 1];
                                    }
                                    else
                                    {
                                        currentTagName = null;
                                    }
                                    // !!!
                                }
                            }
                            // !!!
                        }
                    }
                }
            }
        }
    }
    return htmlNodes;
}

/**
 * 使用HtmlNodes生成对应的Html代码。
 *
 * @param {array} htmlNodes, GSApp.XML.HtmlNode 类型数组。
 * @returns {string} HtmlNodes生成对应的Html代码。
 */
GSApp.XML.createHtml = function (htmlNodes)
{
    var html = "";
    if (htmlNodes.length > 0)
    {
        var htmlNodePathStack = new Array();
        {
            htmlNodePathStack.push(
                {
                    tagName: "",
                    htmlNodes: htmlNodes,
                    nextHtmlNodeIndex: 0
                });
        }
        while (htmlNodePathStack.length > 0)
        {
            var htmlNodePath = htmlNodePathStack[htmlNodePathStack.length - 1];
            var currentHtmlNodes = htmlNodePath.htmlNodes;
            var htmlNodeIndex = htmlNodePath.nextHtmlNodeIndex
            for (;
                htmlNodeIndex < currentHtmlNodes.length;
                htmlNodeIndex++)
            {
                var htmlNode = currentHtmlNodes[htmlNodeIndex];
                if (htmlNode.type == "TEXT")
                {
                    html += htmlNode.text;
                }
                else
                {
                    html += "<" + htmlNode.tagOrignialCodes + ">";
                    if (htmlNode.tagOrignialCodes.indexOf("/")
                        == htmlNode.tagOrignialCodes.length - 1)
                    { }
                    else
                    {
                        /// !!!
                        htmlNodePath.nextHtmlNodeIndex = htmlNodeIndex + 1;
                        htmlNodePathStack.push(
                            {
                                tagName: htmlNode.tagName,
                                htmlNodes: htmlNode.children,
                                nextHtmlNodeIndex: 0
                            });
                        // !!!
                        break;
                        // !!!
                    }
                }
            }

            if (htmlNodeIndex == currentHtmlNodes.length)
            {
                // !!!
                if (htmlNodePath.tagName.length > 0)
                {
                    html += "</" + htmlNodePath.tagName + ">";
                }
                // !!!
                htmlNodePathStack.length--;
            }
        }
    }
    return html;
}