
////////////////////////////////////////////////
/*基础函数*/
////////////////////////////////////////////////
String.prototype.replaceAll = function (key, value)
{
    var regExp = new RegExp(key, "gm");//g,全局;m,多次;i,大小写不敏感
    return this.replace(regExp, value);
};
String.prototype.intNumberDigits = function ()
{
    var dotIndex = this.indexOf(".");
    if (dotIndex < 0)
    {
        return this.length;
    }
    return dotIndex;
};
String.prototype.complementZeroToIntNumberDigits = function (intNumberDigits)
{
    var newString = this;
    while (newString.intNumberDigits() < intNumberDigits)
    {
        newString = "0" + newString;
    }
    return newString;
};
String.prototype.toPureString = function ()
{
    // 删除所有HTML标签：
    var safeContent = this.replace(/<[^<>]+?>/g, '');
    // 普通字符转换成转意符：
    safeContent = safeContent.replace(/[<>&"]/g, function (c) { return { '<': '&lt;', '>': '&gt;', '&': '&amp;', '"': '&quot;' }[c]; });
    // 回车符号转“<br/>”：
    safeContent = safeContent.replaceReturn();

    return safeContent;
};
String.prototype.replaceReturn = function ()
{
    return this.replace(/(\r\n)|(\n)/g, '<br>');
};
Element.prototype.removeAllChild = function ()
{
    while (this.hasChildNodes()) //当div下还存在子节点时 循环继续
    {
        this.removeChild(this.firstChild);
    }
}

////////////////////////////////////////////////
/*模板函数*/
////////////////////////////////////////////////
var _kGSOSBuffer = 0;// 0 未知, 1 iOS, 2 Android
//兼容早期版本未传版本号问题.
var _kGSAppVersionNumberCode = ((typeof (kAppVersion) != "undefined") ? ((kAppVersion != null && kAppVersion != undefined && kAppVersion.toString().length > 0) ? parseInt(kAppVersion.replaceAll("\\.", "")) : 0) : 0);

function gsIsCurrentOSIOS()
{
    if (_kGSOSBuffer == 1)
    {
        return true;
    }
    else if (_kGSOSBuffer == 0)
    {
        if (typeof (kOS) != "undefined")
        {
            if (kOS == "android")
            {
                _kGSOSBuffer = 2;
            }
            else if (kOS == "ios")
            {
                _kGSOSBuffer = 1;
                return true;
            }
        }
        return false;
    }
    return false;
}

function gsIsCurrentOSAndroid()
{
    if (_kGSOSBuffer == 2)
    {
        return true;
    }
    else if (_kGSOSBuffer == 0)
    {
        if (typeof (kOS) != "undefined")
        {
            if (kOS == "android")
            {
                _kGSOSBuffer = 2;
                return true;
            }
            else if (kOS == "ios")
            {
                _kGSOSBuffer = 1;
            }
        }
        return false;
    }
    return false;
}

function gsPureNumber(number)
{
    if (number == null
        || number == undefined) 
    {
        return 0;
    }

    var resultNumber = 0;
    var numberText
        = number.toString();

    if (numberText.indexOf(".") != -1) 
    {
        //小数   
        var dotValue = numberText.substr(numberText.indexOf("."), numberText.length - 1);
        if (Number(dotValue) == 0) 
        {
            //整数
            resultNumber
                = Number(Math.round(numberText));
        }
        else
        {
            resultNumber
                = Number(numberText).toFixed(2);
        }
    }
    else
    {
        //整数
        resultNumber
            = Number(numberText);
    }

    return resultNumber;

}

// 类目
var GS = function () { }

var _kUploadedCommentsStatistics = false;
GS.didWindowScroll = function () 
{
    if (window.screen.height > document.body.scrollHeight
        || document.body.scrollHeight - window.scrollY - window.screen.height < 100)
    {
        ///滑动加载新的元素

        ///////////////////////////////
        /// 7.游戏简介
        ///////////////////////////////
        if (document.body.lastElementChild.id == "gameScore") 
        {
            var currentNode
                = document.getElementById("gameIntro");
            if (currentNode != null
                && currentNode != undefined)
            { }
            else
            {
                GS.addGameIntro();
                return;
            }
        }

        ///////////////////////////////
        /// 8.加载游戏奖杯/成就信息
        ///////////////////////////////
        if (document.body.lastElementChild.id == "gameIntro") 
        {
            var currentNode
                = document.getElementById("gameTrophy");
            if (currentNode != null
                && currentNode != undefined)
            { }
            else
            {
                GS.addGameTrophyBar();
                return;
            }
        }

        ///////////////////////////////
        /// 9.媒体评分
        ///////////////////////////////
        if (document.body.lastElementChild.id == "gameTrophy") 
        {
            var currentNode
                = document.getElementById("mediaScore");
            if (currentNode != null
                && currentNode != undefined)
            { }
            else
            {
                GS.addMediaScores();
                return;
            }
        }

        ///////////////////////////////
        /// 10.玩家点评
        ///////////////////////////////
        if (document.body.lastElementChild.id == "mediaScore") 
        {
            var currentNode
                = document.getElementById("userComments");
            if (currentNode != null
                && currentNode != undefined)
            { }
            else
            {
                GS.addUserGameComments();
                return;
            }
        }

        ///////////////////////////////
        /// 11.精选评测
        ///////////////////////////////

        if (document.body.lastElementChild.id == "userComments") 
        {
            var currentNode
                = document.getElementById("gameEvaluations");
            if (currentNode != null
                && currentNode != undefined)
            { }
            else
            {
                GS.addGameEvaluations();
                return;
            }
        }

        ///////////////////////////////
        /// 12.相关推荐
        ///////////////////////////////
        if (document.body.lastElementChild.id == "gameEvaluations") 
        {
            var currentNode
                = document.getElementById("correlation");
            if (currentNode != null
                && currentNode != undefined)
            { }
            else
            {
                GS.addCorrelation();
                return;
            }
        }
    }

    if (_kUploadedCommentsStatistics == false)
    {
        var commentNode = document.getElementById("userComments");
        if (commentNode != null
            && commentNode != undefined) 
        {
            var targetLineY
                = (commentNode.offsetTop + (commentNode.offsetHeight / 3.0));
            if (window.scrollY + window.innerHeight > targetLineY) 
            {
                GS.reportUMengStatistics("game_0006");
                _kUploadedCommentsStatistics = true;
            }
        }
    }

    var mediaSlider = document.getElementById("mediaSlider");
    if (mediaSlider != null
        && mediaSlider != undefined) 
    {
        if (window.scrollY > (mediaSlider.offsetHeight + mediaSlider.scrollTop + 20)) 
        {
            GS.stopVideo();
        }
    }

    var realPlayTips
        = document.getElementsByClassName("RealPlayerTip");
    if (realPlayTips != null
        && realPlayTips != undefined
        && realPlayTips.length > 0) 
    {
        for (var index = 0; index < realPlayTips.length; index++) 
        {
            const element = realPlayTips[index];
            element.parentElement.removeChild(element);
        }
    }
}

window.onscroll = GS.didWindowScroll;

var kGameId = null;
var kUserId = null;

// 起始入口
GS.loadGame = function () 
{
    var msg
        = "GSApp://get.gameBasic.app?{\"callback\":\"GS.didLoaded\"}";
    GS.sendMessage(msg);
}

// 主体加载方法
GS.didLoaded = function (gameId, userId)
{
    if (gameId != null
        && gameId != undefined
        && Number(gameId) != 0) 
    {
        kGameId = gameId;
    }
    if (userId != null
        && userId != undefined
        && Number(userId) != 0) 
    {
        kUserId = userId;
    }

    ///////////////////////////////
    /// 1.加载视频播放器和媒体资源块
    ///////////////////////////////
    GS.addMediaSlider();

    ///////////////////////////////
    /// 2.加载游戏价格
    ///////////////////////////////
    GS.addGamePrice();

    ///////////////////////////////
    /// 3.活动信息
    ///////////////////////////////
    GS.addGamePrizeActivity();

    ///////////////////////////////
    /// 4.加载游戏基础信息
    ///////////////////////////////
    GS.addGameInfo();

    ///////////////////////////////
    /// 5.加载游戏评分
    ///////////////////////////////
    GS.addGameScore();

	/* 
		其他模块在视图滑动到显示位置之后逐步加载(didWindowScroll)
	*/
}

///检查是否满足滑动加载的条件
GS.checkWhetherNeedToAutoLoadInWindow = function ()
{
    if (window.screen.height > document.body.scrollHeight
        || document.body.scrollHeight - window.scrollY - window.screen.height < 80)
    {
        GS.didWindowScroll();
    }
}

///////////////////////////////
/// 1.加载视频播放器和媒体资源块
///////////////////////////////
GS.addMediaSlider = function ()
{
    var mediaSlider
        = document.createElement("div");
    {
        mediaSlider.className
            = "MediaSlider";
        mediaSlider.id
            = "mediaSlider";
    }

    var screen
        = document.createElement("div");
    screen.className = "Screen";
    screen.id = "screen";
    mediaSlider.appendChild(screen);
    ///!!!
    screen.style.width = window.screen.width + "px";
    screen.style.height = parseInt(window.screen.width / 16 * 9) + "px";
    ///!!!

	/*
		定义消息体:
		open.images.app?{imageCounts:xxx,defaultIndex:xxx}
		defaultSelectedIndex:从0开始
	*/
    screen.onclick = function ()
    {
        var screenChilds
            = screen.childNodes;
        if (screenChilds != null
            && screenChilds != undefined
            && screenChilds.length > 0) 
        {
            var screenChild
                = screenChilds[0];

            if (screenChild.className.indexOf("Image") != -1) 
            {
                if (kGameMedias != null
                    && kGameMedias != undefined
                    && kGameMedias.length > 0) 
                {
                    var imageMedias = Array();
                    var defaultIndex = 0;
                    for (var index = 0; index < kGameMedias.length; index++) 
                    {
                        const media = kGameMedias[index];
                        if (media.mediaType == 1) 
                        {
                            var imageObj
                                = Object();
                            imageObj.imageURL = media.imageSmallURL;
                            imageObj.imageTinyURL = media.imageTinyURL;
                            imageObj.imageHDURL = media.imageURL;
                            imageMedias.push(imageObj);
                        }
                    }

                    if (imageMedias.length > 0) 
                    {
                        kMediaImages = imageMedias;
                    }
                    for (var i = 0; i < kMediaImages.length; i++) 
                    {
                        const media = kMediaImages[i];
                        if (screenChild.id == media.imageageSmallURL
                            || screenChild.id == media.imageTinyURL
                            || screenChild.id == media.imageURL) 
                        {
                            defaultIndex = i;
                            break;
                        }
                    }

                    if (gsIsCurrentOSIOS())
                    {
                        var msg
                            = "GSApp://open.image.app?{\"imageCounts\":\"" + kMediaImages.length + "\""
                            + ", \"defaultIndex\":\"" + defaultIndex + "\""
                            + ", \"callback\":\"GS.getImageInfoWithIndex\"}";
                        GS.sendMessage(msg);
                        return;
                    }
                    else if (gsIsCurrentOSAndroid())
                    {
						/*
						images数组元素定义:
						{
							imageURL:xxx,
							imageTinyURL:xxx,
							imageHDURL:xxx,
						}
						*/
                        var imagesText = "[";
                        for (var i = 0; i < kMediaImages.length; i++) 
                        {
                            const media = kMediaImages[i];
                            imagesText += "{\"imageURL\":\"" + media.imageURL + "\",\"imageTinyURL\":\"" + media.imageTinyURL + "\",\"imageHDURL\":\"" + media.imageHDURL + "\"}";
                            if (i != kMediaImages.length - 1) 
                            {
                                imagesText += ",";
                            }
                        }
                        imagesText += "]";

                        var msg
                            = "GSApp://open.image.app?{\"images\":" + imagesText + ",\"defaultIndex\":\"" + defaultIndex + "\"}";
                        GS.sendMessage(msg);
                        return;
                    }
                }
            }
        }
    }

    var mediaSliderBox
        = document.createElement("div");
    {
        mediaSliderBox.className
            = "MediaSliderBox";
    }
    mediaSlider.appendChild(mediaSliderBox);

    var mediaSliderScrollView
        = document.createElement("div");
    {
        mediaSliderScrollView.className
            = "MediaSliderScrollView";
    }
    mediaSliderBox.appendChild(mediaSliderScrollView);

    var mediaMoreButton
        = document.createElement("div");
    {
        mediaMoreButton.className
            = "MoreButton";
    }

    mediaMoreButton.onclick = function ()
    {
        var msg
            = "GSApp://open.gameMedias.app?{\"gameId\":\"" + kGameId + "\"}";
        GS.sendMessage(msg);
    }

    mediaSlider.appendChild(mediaMoreButton);

    GS.addElement(mediaSlider);

    // 加载数据
    GS.getGameMedias();
}

var kGameVideos = null;
var kSteamVideoMedias = null;
var kSteamImageMedias = null;
var kGameImages = null;
var kGameMedias = null;
GS.getGameMedias = function ()
{
    /*5.4.x 排序规则修改
    展示1个推荐级为1更新时间为最新的视频，
    再展示steam视频，再展示其他推荐级为1的视频，按更新时间降序，最多展示4个；
    */
    /*
        数据请求顺序: 
		1.获取游戏库视频.
		2.获取steam视频和图片.
		3.获取游戏库图片.
		4.获取游戏封面图
	*/

    gsPostToURL("http://appapi2.gamersky.com/game/GameVideos",
        "POST",
        "{\"contentId\":\"" + kGameId + "\",\"recommend\":\"1\",\"pageIndex\":\"1\",\"elementsCountPerPage\":\"10\"}",
        true,
        true,
        "GS.getGameMedias_SteamMedias");
}
GS.getGameMedias_SteamMedias = function (response) 
{
    var videos = null;

    if (response != null
        && response != undefined) 
    {
        var responseJson
            = JSON.parse(decodeURIComponent(response));

        if (responseJson != null
            && responseJson != undefined) 
        {
            if (responseJson.result != null
                && responseJson.result != undefined) 
            {
                if (responseJson.errorCode != null
                    && responseJson.errorCode != undefined) 
                {
                    if (Number(responseJson.errorCode) == 0) 
                    {
                        if (responseJson.result != null
                            && responseJson.result != undefined)
                        {
                            if (responseJson.result.childelements != null
                                && responseJson.result.childelements != undefined) 
                            {
                                videos = responseJson.result.childelements;
                            }
                        }
                    }
                }
            }
            else
            {
                if (responseJson.childelements != null
                    && responseJson.childelements != undefined) 
                {
                    videos = responseJson.childelements;
                }
            }
        }
    }

    var videoMedias
        = Array();
    if (videos != null
        && videos != undefined
        && videos.length > 0) 
    {
        for (var index = 0; index < videos.length; index++) 
        {
            const element = videos[index];
            var media
                = Object();
            media.mediaType = 0;
            media.videoURL = element.videoURL[0];
            media.videoThumbnail = element.genaralImage;
            media.isCover = false;
            if (media.videoURL.indexOf("bilibili") == -1) 
            {
                videoMedias.push(media);
            }
        }
    }

    kGameVideos
        = videoMedias;

    gsPostToURL("http://appapi2.gamersky.com/v4/getGame",
        "POST",
        "{\"gameId\":\"" + kGameId + "\",\"gameModeFieldNames\":\"SteamVideos,SteamImages_HD\",\"gameRelatedFieldNames\":\"\"}",
        true,
        true,
        "GS.getGameMedias_GameImage");
}
GS.getGameMedias_GameImage = function (response) 
{
    var responseJson = null;
    var steamObj = null;
    if (response != null
        && response != undefined) 
    {
        responseJson
            = JSON.parse(decodeURIComponent(response));

        if (responseJson.result != null
            && responseJson.result != undefined) 
        {
            if (responseJson.errorCode != null
                && responseJson.errorCode != undefined) 
            {
                if (Number(responseJson.errorCode) == 0) 
                {
                    steamObj
                        = responseJson.result;
                }
            }
        }
        else
        {
            if (responseJson != null
                && responseJson != undefined) 
            {
                steamObj = responseJson;
            }
        }
    }

    kSteamVideoMedias
        = Array();

    kSteamImageMedias
        = Array();

    var steamVideos = null;
    var steamImages = null;

    if (steamObj != null
        && steamObj != undefined) 
    {
        if (steamObj.SteamVideos != null
            && steamObj.SteamVideos != undefined
            && steamObj.SteamVideos.length > 0) 
        {
            steamVideos
                = JSON.parse(decodeURIComponent(steamObj.SteamVideos));
        }

        if (steamObj.SteamImages_HD != null
            && steamObj.SteamImages_HD != undefined
            && steamObj.SteamImages_HD.length > 0) 
        {
            steamImages
                = JSON.parse(decodeURIComponent(steamObj.SteamImages_HD));
        }

        if (steamVideos != null
            && steamVideos != undefined
            && steamVideos.length > 0)
        {
            var showedSteamVideos
                = Array();

            var originVideos
                = kSteamVideoMedias;
            for (var index = 0; index < steamVideos.length; index++) 
            {
                const element = steamVideos[index];
                var media
                    = Object();
                media.mediaType = 0;
                media.videoURL = element.MoviesWebm480;
                media.videoThumbnail = element.MyMoviesThumbnail;
                media.isCover = false;
                kSteamVideoMedias.push(media);
            }
        }

        if (steamImages != null
            && steamImages != undefined
            && steamImages.length > 0)
        {
            for (var index = 0; index < steamImages.length; index++) 
            {
                const element = steamImages[index];
                var media
                    = Object();
                media.mediaType = 1;
                media.imageTinyURL = element.url;
                media.imageSmallURL = element.url;
                media.imageURL = element.url;
                media.isCover = false;
                kSteamImageMedias.push(media);
            }
        }
    }

    gsPostToURL("http://appapi2.gamersky.com/game/GameAlbums",
        "POST",
        "{\"contentId\":\"" + kGameId + "\",\"recommend\":\"1\",\"pageIndex\":\"1\",\"elementsCountPerPage\":\"10\"}",
        true,
        true,
        "GS.checkGameMediasToShow");
}
GS.checkGameMediasToShow = function (response) 
{
    var images = null;
    var medias = Array();

    if (response != null
        && response != undefined) 
    {
        responseJson
            = JSON.parse(decodeURIComponent(response));

        if (responseJson.result != null
            && responseJson.result != undefined) 
        {
            if (responseJson.errorCode != null
                && responseJson.errorCode != undefined) 
            {
                if (Number(responseJson.errorCode) == 0) 
                {
                    if (responseJson.result != null
                        && responseJson.result != undefined) 
                    {
                        if (responseJson.result.childelements != null
                            && responseJson.result.childelements != undefined) 
                        {
                            images
                                = responseJson.result.childelements;
                        }
                    }
                }
            }
        }
        else
        {
            if (responseJson != null
                && responseJson != undefined) 
            {
                if (responseJson.childelements != null
                    && responseJson.childelements != undefined) 
                {
                    images = responseJson.childelements;
                }
            }
        }

        if (images != null
            && images != undefined
            && images.length > 0) 
        {
            for (var index = 0; index < images.length; index++) 
            {
                const element = images[index];

                var imageUrls
                    = element.image;
                var media
                    = Object();
                media.mediaType = 1;
                media.isCover = false;
                for (var imgIndex = 0; imgIndex < imageUrls.length; imgIndex++) 
                {
                    const imageUrlElement = imageUrls[imgIndex];
                    if (imageUrlElement.indexOf("_tiny") != -1) 
                    {
                        media.imageTinyURL = imageUrlElement;
                    }
                    else if (imageUrlElement.indexOf("_small") != -1) 
                    {
                        media.imageSmallURL = imageUrlElement;
                    }
                    else
                    {
                        media.imageURL = imageUrlElement;
                    }
                }
                medias.push(media);
            }
        }
    }
    kGameImages
        = medias;

    /*5.4.x 排序规则修改
    展示1个推荐级为1更新时间为最新的视频，
    再展示steam视频，再展示其他推荐级为1的视频，按更新时间降序，最多展示4个；
    */

    if (kGameMedias == null)
    {
        kGameMedias
            = new Array();
    }
    if (kGameVideos != null
        && kGameVideos != undefined
        && kGameVideos.length > 0) 
    {
        kGameMedias.push(kGameVideos[0]);
        kGameVideos.splice(0, 1);
    }

    if (kSteamVideoMedias != null
        && kSteamVideoMedias != undefined
        && kSteamVideoMedias.length > 0) 
    {
        kGameMedias
            = kGameMedias.concat(kSteamVideoMedias);
    }

    if (kGameMedias.length > 4) 
    {
        kGameMedias
            = kGameMedias.slice(0, 4);
    }
    else
    {
        kGameMedias
            = kGameMedias.concat(kGameVideos);
        if (kGameMedias.length > 4) 
        {
            kGameMedias
                = kGameMedias.slice(0, 4);
        }
    }

    if (kSteamImageMedias != null
        && kSteamImageMedias != undefined
        && kSteamImageMedias.length > 0) 
    {
        kGameMedias
            = kGameMedias.concat(kSteamImageMedias);
    }

    if (kGameMedias.length > 10) 
    {
        kGameMedias
            = kGameMedias.slice(0, 10);
    }
    else
    {
        if (kGameImages != null
            && kGameImages != undefined
            && kGameImages.length > 0) 
        {
            kGameMedias
                = kGameMedias.concat(kGameImages);
        }

        if (kGameMedias.length > 10) 
        {
            kGameMedias
                = kGameMedias.slice(0, 10);
        }
    }

    if (kGameMedias != null
        && kGameMedias != undefined
        && kGameMedias.length > 0) 
    {
        GS.addMediaElements(kGameMedias);
    }
    else
    {
        gsPostToURL("http://appapi2.gamersky.com/v4/getGame",
            "POST",
            "{\"gameId\":\"" + kGameId + "\",\"gameModeFieldNames\":\"\",\"gameRelatedFieldNames\":\"defaultPicUrl\"}",
            true,
            true,
            "GS.didGetGameCover");
    }
}
GS.didGetGameCover = function (response) 
{
    var coverImage = null;
    if (response != null
        && response != undefined) 
    {
        responseJson
            = JSON.parse(decodeURIComponent(response));

        if (responseJson.result != null
            && responseJson.result != undefined) 
        {
            if (responseJson.errorCode != null
                && responseJson.errorCode != undefined) 
            {
                if (Number(responseJson.errorCode) == 0) 
                {
                    coverImage
                        = responseJson.result;
                }
            }
        }
        else
        {
            if (responseJson != null
                && responseJson != undefined) 
            {
                coverImage = responseJson;
            }
        }
    }
    if (coverImage != null
        && coverImage != undefined) 
    {
        var imageUrl
            = coverImage.defaultPicUrl;

        if (imageUrl != null
            && imageUrl != undefined
            && imageUrl.length > 0) 
        {
            var media = Object();
            {
                media.mediaType = 1;
                media.imageTinyURL = imageUrl;
                media.imageSmallURL = imageUrl;
                media.imageURL = imageUrl;
                media.isCover = true;
            }
            GS.addMediaElements([media]);
            kGameMedias.push(media);
        }
    }
}

//media元素添加方法
var mediaNodeArray = Array();
var kSelectedMediaIndex = 0;
GS.addMediaElements = function (medias)
{
    if (medias != null
        && medias != undefined
        && medias.length > 0) 
    {
        var mediaSliderNode
            = document.getElementsByClassName("MediaSliderScrollView")[0];

        for (var index = 0; index < medias.length; index++) 
        {
            const mediaDic = medias[index];
            var mediaType = mediaDic.mediaType;
            var msg = null;
            var mediaNode
                = document.createElement("div");
            var mediaURL = "";
            if (mediaType == 0)
            {
                //视频媒体
                mediaURL = mediaDic.videoThumbnail;
                mediaNode.setAttribute("mediaType", "Video");
                if (mediaDic.videoURL.indexOf(".webm") != -1)
                {
                    mediaDic.videoURL
                        = mediaDic.videoURL.replace(".webm", ".mp4");
                }
                msg
                    = "GSApp://download.image.app?{\"url\":\"" + mediaURL + "\",\"callback\":\"GS.showMediaItemImage\"}";

                var playNode = document.createElement("div");
                {
                    playNode.className = "InnerBorder PlayTip";
                }
                mediaNode.appendChild(playNode);
            }
            else if (mediaType == 1)
            {
                //图片媒体
                mediaURL = mediaDic.imageTinyURL;
                mediaNode.setAttribute("mediaType", "Image");
                mediaNode.setAttribute("isCover", mediaDic.isCover);
                msg
                    = "GSApp://download.image.app?{\"url\":\"" + mediaURL + "\",\"callback\":\"GS.showMediaItemImage\"}";

                var playNode = document.createElement("div");
                {
                    playNode.className = "InnerBorder";
                }
                mediaNode.appendChild(playNode);
            }

            mediaNode.id = mediaURL;
            mediaNode.setAttribute("imgSrc", mediaURL);
            mediaNode.onclick = function ()
            {
                var idx
                    = mediaNodeArray.indexOf(this);

                if (kGameMedias != null
                    && kGameMedias != undefined
                    && kGameMedias.length > idx) 
                {
                    var changedMedia = kGameMedias[idx];

                    if (this.getAttribute("selectedState") != null
                        && this.getAttribute("selectedState") != undefined
                        && this.getAttribute("selectedState") != "selected") 
                    {
                        GS.didChangeMediaItem(changedMedia);
                    }
                }
            }

            if (index == 0)
            {
                mediaNode.className = "MediaItem Selected";
                mediaNode.setAttribute("selectedState", "selected");
            }
            else
            {
                mediaNode.className = "MediaItem";
                mediaNode.setAttribute("selectedState", "unselected");
            }

            mediaSliderNode.appendChild(mediaNode);
            mediaNodeArray.push(mediaNode);

            GS.sendMessage(msg);
        }
        mediaSliderNode.style.width
            = (mediaNodeArray.length * (80 + 2) + 2) + "px";
    }

    //默认选择第一个元素
    if (medias != null
        && medias != undefined
        && medias.length > 0) 
    {
        var firstMedia
            = medias[0];
        if (firstMedia.mediaType == 0) 
        {
            GS.didChangeVideoPlayerNodeToPlay(firstMedia.videoThumbnail, firstMedia.videoURL);
            return;
        }
        else if (firstMedia.mediaType == 1)
        {
            GS.sendMessage("GSApp://download.image.app?{\"url\":\"" + firstMedia.imageSmallURL + "\",\"callback\":\"GS.defaultSelecteFirstMediaItem\"}");
        }
    }
}

GS.defaultSelecteFirstMediaItem = function (srcImageURL, staticImageURL, isCover)
{
    GS.didChangeMediaSliderScreenToImage(srcImageURL, staticImageURL, isCover);
}

GS.showMediaItemImage = function (imgSrc, imgStaticsSrc) 
{
    var medias
        = document.getElementsByClassName("MediaItem");

    var mediaItem = null;
    for (var i = 0; i < medias.length; i++) 
    {
        const media = medias[i];
        if (media.id == imgSrc) 
        {
            mediaItem = media;
            break;
        }
    }

    console.log(imgSrc + "," + imgStaticsSrc);
    if (mediaItem != null
        && mediaItem != undefined) 
    {
        if (mediaItem.getAttribute("imgSrc") != null
            && mediaItem.getAttribute("imgSrc") != undefined
            && mediaItem.getAttribute("imgSrc").length > 0) 
        {
            if (mediaItem.getAttribute("imgSrc").indexOf(imgSrc) != -1) 
            {
                var mediaItemClassName = mediaItem.className;
                {
                    mediaItemClassName = mediaItemClassName.replace("Cover", "");
                }
                mediaItem.setAttribute("imgStaticSrc", imgStaticsSrc);
                mediaItem.style.backgroundImage
                    = "url(" + imgStaticsSrc + ")";
                mediaItem.style.backgroundSize = "80px 46px";
                mediaItem.style.backgroundPosition = "center";
                mediaItem.style.backgroundRepeat = "no-repeat";

                if (mediaItem.parentNode.className == "MediaSliderScrollView"
                    && (mediaItem.getAttribute("isCover") == "true"
                        || mediaItem.getAttribute("isCover") == true))
                {
                    mediaItemClassName += "Cover";
                    mediaItem.style.backgroundPosition = "center";
                    mediaItem.style.backgroundSize = "cover";
                    mediaItem.style.backgroundRepeat = "no-repeat";
                }
                // !!!
                mediaItem.className = mediaItemClassName;
                // !!!
            }
            else
            {
                console.log(mediaItem.getAttribute("imgSrc"));
            }
        }
    }
}

//媒体元素和大屏幕切换
GS.didChangeMediaItem = function (mediaDic) 
{
    var mediaId = null;
    var mediaSelected = null;

    if (mediaDic.mediaType == 0)
    {
        mediaId = mediaDic.videoThumbnail;
    }
    else if (mediaDic.mediaType == 1)
    {
        mediaId = mediaDic.imageTinyURL;
    }

    var medias
        = document.getElementsByClassName("MediaItem");

    if (medias != null
        && medias != undefined
        && medias.length > 0) 
    {
        for (var index = 0; index < medias.length; index++) 
        {
            const element = medias[index];
            if (element.id == mediaId) 
            {
                mediaSelected = element;
                break;
            }
        }
    }

    if (mediaDic.mediaType == 0) 
    {
        if (mediaSelected.getAttribute("selectedState") == "selected") 
        {
            return;
        }
        //视频	
        {
            GS.didChangeVideoPlayerNodeToPlay(mediaDic.videoThumbnail, mediaDic.videoURL);
        }
    }
    else if (mediaDic.mediaType == 1)
    {
        if (mediaSelected.getAttribute("selectedState") == "selected") 
        {
            return;
        }
        // !!! 先关闭视频 !!!
        GS.sendMessage("GSApp://close.video.app");

        //图片
        GS.sendMessage("GSApp://download.image.app?{\"url\":\"" + mediaDic.imageSmallURL + "\",\"callback\":\"GS.didChangeMediaSliderScreenToImage\"}");
    }

    ///元素变化
    if (medias != null
        && medias != undefined
        && medias.length > 0) 
    {
        for (var index = 0; index < medias.length; index++) 
        {
            const element = medias[index];
            if (element.id == mediaId)
            {
                element.className = "MediaItem Selected";
                element.setAttribute("selectedState", "selected");
            }
            else
            {
                element.className = "MediaItem";
                element.setAttribute("selectedState", "unselected");
            }
        }
    }
    mediaSelected.setAttribute("selectedState", "selected");
}

var kIsVideoHadPlayed = false;
GS.createVideoPlayerPlayingHolder = function (imageURL, videoURL)
{
    var playingHolderNode
        = document.createElement("div");
    playingHolderNode.className = "PlayingHolder";
    playingHolderNode.id = "playingHolder";
    playingHolderNode.style.backgroundImage = "url('" + imageURL + "')";
    {
        var videoMaskDiv
            = document.createElement("div");
        {
            videoMaskDiv.className = "VideoMask";
            //
            var playingHolderButton
                = document.createElement("div");
            {
                playingHolderButton.className = "HolderButton";
                playingHolderButton.onclick = function ()
                {
                    kIsVideoHadPlayed = true;
                    GS.didChangeVideoPlayerNodeToPlay(imageURL, videoURL);
                };
            }
            videoMaskDiv.appendChild(playingHolderButton);
        }
    }
    playingHolderNode.appendChild(videoMaskDiv);
    return playingHolderNode;
}

GS.didChangeVideoPlayerNodeToPlay = function (imageURL, videoURL) 
{
	/*
	var screen
	= document.getElementById("screen");

	screen.removeAllChild();

	var videoPlayerBack
	= document.createElement("div");
	videoPlayerBack.id = "videoPlayerBack";
	screen.appendChild(videoPlayerBack);
	
	// !!! 下载更新视频图片 !!!
	GS.sendMessage("GSApp://download.image.app?{\"url\":\""+imageURL+"\",\"callback\":\"GS.didShowScreenVideoPlayerBackgroundImage\"}");
	*/

    var screen = document.getElementById("screen");
    if (screen)
    {
        screen.removeAllChild();
        screen.appendChild(GS.createVideoPlayerPlayingHolder(imageURL, videoURL));
    }

    if (kIsVideoHadPlayed == false) 
    {
        return;
    }

    var videoSourceFrame =
        "[0, 0, " + window.innerWidth + ", " + parseInt(window.innerWidth * 9 / 16) + "]";

    var youKuVideoId = GSApp_Video.getYouKuVideoIdWithContentURL(videoURL);
    if (youKuVideoId != null
        && youKuVideoId.length > 0)
    {
        videoURL = "";
    }
    else
    {
        youKuVideoId = "";
    }
    GS.sendMessage(
        "GSApp://play.video.app?{\"id\":\"" + videoURL + "\""
        + ", \"videoSrc\":\"" + videoURL + "\""
        + ", \"youKuVideoId\":\"" + youKuVideoId + "\""
        + ", \"frame\":" + videoSourceFrame + "}");
}

GS.didShowScreenVideoPlayerBackgroundImage = function (imageURL, imageStaticURL) 
{
    var videoPlayerBack
        = document.getElementById("playingHolder");
    videoPlayerBack.style.background = "url(\"" + imageStaticURL + "\") no-repeat";
    videoPlayerBack.style.backgroundSize = "cover";
}

GS.didChangeMediaSliderScreenToImage = function (imageURL, imageStaticURL, isCover) 
{
    var screen
        = document.getElementById("screen");

    screen.removeAllChild();

    var imageSrc = imageURL;
    if (imageSrc.indexOf("_tiny") != -1) 
    {
        imageSrc
            = imageSrc.replace("_tiny", "_small");
    }
    var imageNode
        = document.createElement("div");

    if (isCover == true) 
    {
        imageNode.className = "Image Cover";
        imageNode.id = "id_" + imageURL;
        imageNode.setAttribute("isCover", true);
    }
    else
    {
        imageNode.className = "Image";
        imageNode.id = imageURL;

    }
    imageNode.style.background = "url(\"" + imageStaticURL + "\") no-repeat";

    imageNode.style.backgroundPosition = "center";
    if (isCover == true) 
    {
        imageNode.setAttribute("isCover", true);
    }
    else
    {
        imageNode.style.backgroundSize = "cover";
    }

    screen.appendChild(imageNode);

    GS.sendMessage("GSApp://download.image.app?{\"url\":\"" + imageSrc + "\",\"callback\":\"GS.showMediaSliderImageOnScreen\"}");
}
GS.showMediaSliderImageOnScreen = function (imageURL, imageSrc) 
{
    var imageNode
        = document.getElementById(imageURL);
    if (imageNode) 
    {
        if (imageSrc != null
            && imageSrc != undefined
            && imageSrc.length > 0) 
        {
            imageNode.style.background
                = "url(\"" + imageSrc + "\") no-repeat";

            if (imageNode.className.indexOf("Cover") != -1) 
            {
                imageNode.style.backgroundSize
                    = "auto";
                imageNode.style.backgroundPosition
                    = "center";
            }
            else
            {
                imageNode.style.backgroundSize
                    = "cover";
                imageNode.style.backgroundPosition
                    = "center";
            }
        }
    }
}

GS.pauseVideo = function ()
{
    var video
        = document.getElementById("videoPlayer");
    if (video != null
        && video != undefined) 
    {
        if (video.paused == false) 
        {
            video.pause();
        }
    }
}

GS.stopVideo = function ()
{
    GS.pauseVideo();
}

///视频元素对象
// var kVideoNode = null;
var GSApp_Video = function ()
{ };
GSApp_Video.kYouKuVideoIdEndSign = "==";
GSApp_Video.getYouKuVideoIdWithContentURL = function (videoContent)
{
    // 尝试获取优酷视频Id.
    var youkuVideoId = null;
    if (videoContent != null
        && videoContent.length > -1)
    {
        // 去除空格.
        videoContent = videoContent.replace(new RegExp(" ", "gm"), "");
        // 保存原始视频内容.
        var originVideoContent = videoContent;
        // 小写化.
        videoContent = videoContent.toLowerCase();

        // 尝试从URL格式的视频代码中获取视频Id.
        var urlPlayerSign
            = "://v.youku.com/v_show/id_";// "http://v.youku.com/v_show/id_"
        var indexOfURLPlayerSign
            = videoContent.indexOf(urlPlayerSign);


        if (indexOfURLPlayerSign > -1)
        {
            var youkuVideoIdBeginCharIndex
                = indexOfURLPlayerSign + urlPlayerSign.length;
            var youkuVideoIdEndCharIndex
                = videoContent.indexOf(
                    GSApp_Video.kYouKuVideoIdEndSign,
                    youkuVideoIdBeginCharIndex);
            if (youkuVideoIdEndCharIndex >= 0)
            {
                youkuVideoIdEndCharIndex
                    = youkuVideoIdEndCharIndex
                    + GSApp_Video.kYouKuVideoIdEndSign.length;
            }
            else
            {
                youkuVideoIdEndCharIndex
                    = videoContent.indexOf(
                        ".",
                        youkuVideoIdBeginCharIndex);
                if (youkuVideoIdEndCharIndex < 0)
                {
                    youkuVideoIdEndCharIndex
                        = videoContent.length;
                }
            }
            youkuVideoId
                = originVideoContent.substring(
                    youkuVideoIdBeginCharIndex,
                    youkuVideoIdEndCharIndex);
        }
        else
        {
            // 尝试从iFrame格式的视频代码中获取视频Id.
            var iFramePlayerSign
                = "://player.youku.com/embed/";// "http://player.youku.com/embed/";
            var indexOfiFramePlayerSign
                = videoContent.indexOf(iFramePlayerSign);
            if (indexOfiFramePlayerSign > -1)
            {
                var youkuVideoIdBeginCharIndex
                    = indexOfiFramePlayerSign + iFramePlayerSign.length;
                var youkuVideoIdEndCharIndex
                    = videoContent.indexOf(
                        GSApp_Video.kYouKuVideoIdEndSign,
                        youkuVideoIdBeginCharIndex);
                if (youkuVideoIdEndCharIndex != -1)
                {
                    youkuVideoIdEndCharIndex
                        += GSApp_Video.kYouKuVideoIdEndSign.length;
                }
                else
                {
                    youkuVideoIdEndCharIndex
                        = originVideoContent.length;
                }
                youkuVideoId
                    = originVideoContent.substring(youkuVideoIdBeginCharIndex, youkuVideoIdEndCharIndex);
            }
            else
            {
                // 尝试从JS格式的视频代码中获取视频Id.
                var jsPlayerSign
                    = "vid:'";
                var indexOfJSPlayerSign
                    = videoContent.indexOf(jsPlayerSign);
                if (indexOfJSPlayerSign > -1)
                {
                    var youkuVideoIdBeginCharIndex
                        = indexOfJSPlayerSign + jsPlayerSign.length;
                    var youkuVideoIdEndCharIndex
                        = videoContent.indexOf(
                            GSApp_Video.kYouKuVideoIdEndSign,
                            youkuVideoIdBeginCharIndex)
                        + GSApp_Video.kYouKuVideoIdEndSign.length;
                    youkuVideoId
                        = originVideoContent.substring(youkuVideoIdBeginCharIndex,
                            youkuVideoIdEndCharIndex);
                }
            }
        }
    }
    return youkuVideoId;
};

//iOS图片浏览器获取图片方法
var kMediaImages = null;
GS.getImageInfoWithIndex = function (index)
{
	/*
	回调消息体
	{index:index,imageURL:xxx,imageTinyURL:xxx,imageHDURL:xxx};
	*/
    if (kMediaImages != null
        && kMediaImages != undefined
        && kMediaImages.length > 0) 
    {
        if (index >= 0
            && index < kMediaImages.length) 
        {
            var media
                = kMediaImages[index];

            var imageSourceFrame =
                "[0, 0, " + window.innerWidth + ", " + parseInt(window.innerWidth * 9 / 16) + "]";

            var msg
                = "{\"index\":\"" + index + "\""
                + ", \"imageURL\":\"" + media.imageURL + "\""
                + ", \"imageTinyURL\":\"" + media.imageTinyURL + "\""
                + ", \"imageHDURL\":\"" + media.imageHDURL + "\""
                + ", \"frame\":" + imageSourceFrame + "}";

            return msg;
        }
    }
}


///////////////////////////////
/// 2.加载游戏价格
///////////////////////////////

var kGamePriceData = null;
GS.addGamePrice = function () 
{
    if (_kGSAppVersionNumberCode < 510) 
    {
        return;
    }
    var gamePriceNode
        = document.createElement("div");
    gamePriceNode.id = "gamePrice";
    GS.addElement(gamePriceNode);

    gsPostToURL("http://appapi2.gamersky.com/v4/getGame",
        "POST",
        "{\"gameId\":\"" + kGameId + "\",\"gameModeFieldNames\":\"AllTimeT,SteamId,IsFree,SteamPrice,SteamInitial,SteamFinal,DiscountPercent,DiscountText,Ps4IsFree,Ps4Price,Ps4RewardsPrice,Ps4Url,ThirdpartyProhibition,steamPriceOverdueTime,psnPriceOverdueTime\",\"gameRelatedFieldNames\":\"playCount,wantplayCount,expectCount\"}",
        true,
        true,
        "GS.getFengHuangePrice");
};

GS.getFengHuangePrice = function (normalPriceData) 
{
    if (normalPriceData != null
        && normalPriceData.length > 0) 
    {
        priceResult
            = JSON.parse(decodeURIComponent(normalPriceData));
        if (priceResult != null) 
        {
            if (priceResult.result != null
                && priceResult.result != undefined) 
            {
                kGamePriceData
                    = priceResult.result;
            }
            else
            {
                kGamePriceData
                    = priceResult;
            }
        }
    }

    gsPostToURL("https://db2.gamersky.com/GameDistributor.aspx?game_id=" + kGameId + "&callback=jQuery183038719990876028576_1561022156892&_=1561022157075",
        "GET",
        "",
        false,
        true,
        "GS.didGetFengHuangePrice");
}

GS.didGetFengHuangePrice = function (fengHuangePriceData) 
{
    var fengHuangePriceResult;
    if (fengHuangePriceData != null
        && fengHuangePriceData.length > 0) 
    {
        try
        {
            fengHuangePriceData
                = decodeURIComponent(fengHuangePriceData);

            ///兼容.
            if (fengHuangePriceData.indexOf("result") != -1) 
            {
                fengHuangePriceData
                    = JSON.parse(decodeURIComponent(fengHuangePriceData));

                fengHuangePriceData
                    = fengHuangePriceData.result;
            }
            if (fengHuangePriceData.result != null
                && fengHuangePriceData.result != undefined) 
            {
                fengHuangePriceData
                    = fengHuangePriceData.result;
            }
            if (fengHuangePriceData.indexOf("({") != -1
                && fengHuangePriceData.indexOf("})") != -1) 
            {
                fengHuangePriceData
                    = fengHuangePriceData.substr(fengHuangePriceData.indexOf("({") + 1, fengHuangePriceData.length - fengHuangePriceData.indexOf("{") - 1);

                fengHuangePriceData
                    = fengHuangePriceData.substr(0, fengHuangePriceData.indexOf("})") + 1);
            }

            fengHuangePriceResult
                = JSON.parse(fengHuangePriceData);
        }
        catch (error)
        {
            console.log(error.toString());
        }


        if (fengHuangePriceResult != null) 
        {
            if (fengHuangePriceResult.status == 1)
            {
                var fhpriceData
                    = fengHuangePriceResult.data;
                kGamePriceData.FengHuangePrice = fhpriceData.price;
                kGamePriceData.FengHuangeOriginPrice = fhpriceData.oldprice;
                kGamePriceData.FengHuangeUrl = fhpriceData.url;
            }
        }
    }

    ///获取汇率
    GS.getHKRate();
}

var kRMBToHKDRate = 0;
GS.getHKRate = function () 
{
    var msg
        = "GSApp://get.rate.app?{\"rate\":\"HK\",\"callback\":\"GS.didGetHKRate\"}";
    GS.sendMessage(msg);
}

GS.didGetHKRate = function (rate) 
{
    kRMBToHKDRate = rate;
    kGamePriceData.Ps4FinalPrice
        = (kGamePriceData.Ps4RewardsPrice / Number(rate)).toFixed(2);

    ///最后试着获取steam评论数据
    GS.tryToGetSteamPraiseInfo();
}

GS.tryToGetSteamPraiseInfo = function () 
{
    GS.getGameInfo("GS.didGetGamePriceData");
}

GS.didGetGamePriceData = function (gameInfos) 
{
    kGameInfo
        = GS.transferGameInfoIntoContent(gameInfos)

    var platform;       //平台
    var price;          //当前售价
    var originPrice;    //原价
    var lowestPrice;    //最低价格
    var discount;       //折扣比例
    var discountText;   //折扣说明

    var isFree;         //是否免费

    var praiseInfo = kGameInfo.GoodText;

    if (kGamePriceData.SteamFinal != null
        && kGamePriceData.SteamFinal.toString().length > 0
        && isNaN(kGamePriceData.SteamFinal.toString()) == false
        && Number(kGamePriceData.SteamFinal) != 0) 
    {
        //优先展示
        platform = "Steam";
        lowestPrice = kGamePriceData.SteamPrice;
        price = kGamePriceData.SteamFinal;
        originPrice = kGamePriceData.SteamInitial;
        discount = kGamePriceData.DiscountPercent;
    }
    else if (kGamePriceData.Ps4FinalPrice != null
        && kGamePriceData.Ps4FinalPrice.toString().length > 0
        && isNaN(kGamePriceData.Ps4FinalPrice.toString()) == false
        && Number(kGamePriceData.Ps4FinalPrice) != 0) 
    {
        platform = "PSN";
        price = kGamePriceData.Ps4FinalPrice;
        originPrice = (kGamePriceData.Ps4Price / kRMBToHKDRate).toFixed(2);
    }
    else if (kGamePriceData.FengHuangePrice != null
        && kGamePriceData.FengHuangePrice.toString().length > 0
        && isNaN(kGamePriceData.FengHuangePrice.toString()) == false
        && Number(kGamePriceData.FengHuangePrice) != 0
        && kGamePriceData.FengHuangeUrl != null
        && kGamePriceData.FengHuangeUrl != undefined
        && kGamePriceData.FengHuangeUrl.length > 0
        && kGamePriceData.FengHuangeUrl.indexOf("gamersky.fhyx.com") != -1) 
    {
        platform = "FengHuang";
        price = kGamePriceData.FengHuangePrice;
        originPrice = kGamePriceData.FengHuangeOriginPrice;
    }
    else
    {
        return;
    }

    //是否免费

    if (platform == "Steam")
    {
        if (kGamePriceData.IsFree.indexOf("True") != -1)
        {
            isFree = true;
        }
    }
    else if (platform == "PSN")
    {
        if (kGamePriceData.Ps4IsFree.indexOf("True") != -1)
        {
            isFree = true;
        }
    }

    ///免费游戏不展示游戏栏.
    if (isFree == true)
    {
        return;
    }

    ///有优惠信息的情况
    var discountIsOver = null;
    var parseDay = null;
    if (Number(price) != Number(originPrice)) 
    {
        var deadLineTimeStamp = "";

        if (platform == "Steam")
        {
            deadLineTimeStamp = kGamePriceData.steamPriceOverdueTime;
        }
        else if (platform == "PSN")
        {
            deadLineTimeStamp = kGamePriceData.psnPriceOverdueTime;
        }

        if (deadLineTimeStamp != null
            && deadLineTimeStamp != undefined) 
        {
            if (deadLineTimeStamp.toString() != null
                && deadLineTimeStamp.toString().length > 0
                && isNaN(deadLineTimeStamp) == false
                && Number(deadLineTimeStamp) != 0) 
            {
                var overDate = new Date(Math.round(deadLineTimeStamp));
                var nowDate = new Date();
                parseDay = (overDate.getTime() - nowDate.getTime()) / (24 * 60 * 60 * 1000);

                if (parseDay < 0) 
                {
                    discountIsOver = true;
                    //折扣截止日早于当前日期的情况,现价=原价.
                    price = originPrice;
                }
            }
        }
    }

    //小数位判断//
    price = gsPureNumber(price);
    originPrice = gsPureNumber(originPrice);

    if (price != null
        && price != undefined
        && price.toString().length > 0) 
    {
        discount = 0;

        if (price != null
            && price != undefined
            && originPrice != null
            && originPrice != undefined) 
        {
            if (isNaN(Number(originPrice)) == false
                && Number(originPrice) != 0) 
            {
                if (Number(price) != Number(originPrice))
                {
                    discount = parseInt(Math.round((1 - price / originPrice) * 100));
                }
            }
        }

        var gamePriceNode
            = document.getElementById("gamePrice");
        gamePriceNode.className = "GamePrice";

        var platformNode
            = document.createElement("div");
        platformNode.className = "Platform" + " " + platform;
        gamePriceNode.appendChild(platformNode);

        //添加元素
        var priceNode
            = document.createElement("span");
        priceNode.className = "Price";
        gamePriceNode.appendChild(priceNode);

        var priceShowingNode
            = document.createElement("div");
        priceShowingNode.className = "PriceShowing";
        if (gsIsCurrentOSAndroid() == true) 
        {
            priceShowingNode.className = "PriceShowing Android";
        }
        priceNode.appendChild(priceShowingNode);

        var priceSignNode
            = document.createElement("span");
        priceSignNode.className = "PriceSign";
        priceSignNode.innerText = "￥";
        priceShowingNode.appendChild(priceSignNode);

        var priceTextNode
            = document.createElement("span");
        priceTextNode.className = "Price";
        priceTextNode.innerText = parseInt(price);
        priceShowingNode.appendChild(priceTextNode);

        var priceSubNode
            = document.createElement("div");
        priceSubNode.className = "PriceSub";
        priceNode.appendChild(priceSubNode);
        {
            var lowestNode
                = document.createElement("div");
            lowestNode.className = "Lowest Only";
            priceSubNode.appendChild(lowestNode);
            if (lowestPrice != null
                && lowestPrice != undefined
                && lowestPrice.length > 0
                && isNaN(lowestPrice) == false) 
            {
                lowestNode.innerText = "历史最低价：￥" + lowestPrice;
            }
            else
            { }

            if (discount != 0) 
            {
                var subInfoNode
                    = document.createElement("div");
                subInfoNode.className = "SubInfo";
                priceSubNode.appendChild(subInfoNode);

                var discountNode
                    = document.createElement("div");
                discountNode.className = "Discount";
                subInfoNode.appendChild(discountNode);
                discountNode.innerText = "-" + discount + "%";

                var originPriceNode
                    = document.createElement("div");
                originPriceNode.className = "OriginPrice";
                subInfoNode.appendChild(originPriceNode);
                originPriceNode.innerText = "￥" + originPrice;

                var deadLineTime = null;
                var deadLineText = null;

                if (deadLineTimeStamp.toString() != null
                    && deadLineTimeStamp.toString() != undefined
                    && deadLineTimeStamp.toString().length > 0) 
                {
                    if (discountIsOver != null
                        && discountIsOver == true)
                    { }
                    else
                    {
                        if (parseDay < 1) 
                        {
                            var parseHour
                                = parseInt(parseDay * 24);

                            if (parseHour == 0) 
                            {
                                discountText = "不足1小时";
                            }
                            else
                            {
                                deadLineTime = parseInt(parseHour) + "小时";
                                discountText = "剩余" + deadLineTime;
                            }
                        }
                        else
                        {
                            deadLineTime = parseInt(parseDay) + "天";
                            discountText = "剩余" + deadLineTime;
                        }
                    }
                }

                if (discountText != null
                    && discountText != undefined
                    && discountText.length > 0) 
                {
                    var discountInfoNode
                        = document.createElement("div");
                    discountInfoNode.className = "DiscountInfo";
                    subInfoNode.appendChild(discountInfoNode);
                    discountInfoNode.innerText = discountText;
                }

                lowestNode.className = "Lowest";
            }
        }

        ///最后添加steam好评元素

        if (platform == "Steam"
            && praiseInfo != null
            && praiseInfo.length > 0) 
        {
            var steamPraiseNode
                = document.createElement("span");
            gamePriceNode.appendChild(steamPraiseNode);
            steamPraiseNode.className = "SteamPraise";

            var praiseTipNode
                = document.createElement("div");
            steamPraiseNode.appendChild(praiseTipNode);
            praiseTipNode.className = "PraiseTip Hide";


            var praiseRecordNode
                = document.createElement("div");
            steamPraiseNode.appendChild(praiseRecordNode);
            praiseRecordNode.className = "PraiseRecord Single";
            praiseRecordNode.innerText = "Steam好评率：" + praiseInfo + "%";

        }
    }
}

///////////////////////////////
/// 3.活动信息
///////////////////////////////
GS.addGamePrizeActivity = function () 
{
    var prizeNode
        = document.createElement("div");
    prizeNode.id = "gamePrizeActivity";
    GS.addElement(prizeNode);

    gsPostToURL("http://appapi2.gamersky.com/v4/getGame",
        "POST",
        "{\"gameId\":\"" + kGameId + "\",\"gameModeFieldNames\":\"Activity,Position\",\"gameRelatedFieldNames\":\"\"}",
        true,
        true,
        "GS.checkGamePrizeActivityLink");

}
GS.checkGamePrizeActivityLink = function (prizeActivityContent) 
{
    var activityResult
        = JSON.parse(decodeURIComponent(prizeActivityContent));

    var activity = null;
    var position = null;
    if (activityResult != null
        && activityResult != undefined) 
    {
        if (activityResult.Activity != null
            && activityResult.Activity != undefined) 
        {
            activity
                = activityResult.Activity;
        }
        if (activityResult.Position != null
            && activityResult.Position != undefined) 
        {
            position
                = activityResult.Position;
        }

        if (position != null
            && position != undefined
            && position.length > 0
            && position.indexOf("活动") != -1)
        {
            if (activity != null
                && activity != undefined
                && activity.length > 0) 
            {
                var activityNode
                    = document.createElement("div");
                activityNode.innerHTML
                    = activity;
                ///!!!
                activityNode.style.display = "none"; //一个私有元素
                ///!!!
                document.body.appendChild(activityNode);

                var moreList = document.getElementsByClassName("more");
                var activityLink = null;
                if (moreList != null
                    && moreList != undefined
                    && moreList.length > 0) 
                {
                    for (var index = 0; index < moreList.length; index++) 
                    {
                        const element = moreList[index];
                        if (element.tagName == "A"
                            && element.getAttribute("href") != null
                            && element.getAttribute("href") != undefined
                            && element.getAttribute("href").length > 0) 
                        {
                            activityLink = element.getAttribute("href");
                            break;
                        }
                    }
                }
                document.body.removeChild(activityNode);

                if (activityLink != null)
                {
                    GS.addGamePrizeActivityElement(activityLink);
                }
            }
        }
    }
}
GS.addGamePrizeActivityElement = function (contentURL) 
{
    var prizeNode
        = document.getElementById("gamePrizeActivity");

    if (contentURL != null
        && contentURL != undefined
        && contentURL.length > 0) 
    {
        if (prizeNode != null
            && prizeNode != undefined) 
        {
            prizeNode.className
                = "GamePrizeActivity";

            prizeNode.onclick = function () 
            {
                GS.openGamePrizeActivity(contentURL);
            }

            var prizeIconNode
                = document.createElement("div");
            prizeIconNode.className
                = "icon";
            prizeNode.appendChild(prizeIconNode);

            var prizeCapNode
                = document.createElement("div");
            prizeCapNode.className
                = "cap";
            prizeCapNode.innerText = "参与游民众评＂你评我送＂";
            prizeNode.appendChild(prizeCapNode);

            var prizeMainNode
                = document.createElement("div");
            prizeMainNode.innerText = "有奖活动";
            prizeMainNode.className
                = "mainCap";
            prizeNode.appendChild(prizeMainNode);
        }
    }
    else
    {
        prizeNode.remove();
    }
}

//action
GS.openGamePrizeActivity = function (contentURL) 
{
    if (contentURL != null
        && contentURL != undefined
        && contentURL.length > 0) 
    {
        var message
            = "GSApp://open.url.app?{\"url\":\"" + contentURL + "\"}";
        GS.sendMessage(message);
    }
}

///////////////////////////////
/// 4.加载游戏基础信息
///////////////////////////////
GS.addGameInfo = function () 
{
    var gameInfoNode
        = document.createElement("div");
    gameInfoNode.id = "gameInfo";
    GS.addElement(gameInfoNode);

    GS.getGameInfo("GS.addGameInfoElements");
}
GS.addGameInfoElements = function (gameInfoJson) 
{
    var gameInfo = null;

    if (gameInfoJson != null
        && gameInfoJson != undefined
        && gameInfoJson.length > 0) 
    {
        gameInfo
            = GS.transferGameInfoIntoContent(gameInfoJson);

        if (gameInfo)
        {
            var gameInfoBarNode
                = document.getElementById("gameInfo");
            {
                gameInfoBarNode.className
                    = "GameInfoBar"
            }

            //游戏配置
            var gameConfigNode
                = document.createElement("div");
            gameInfoBarNode.appendChild(gameConfigNode);
            gameConfigNode.className = "GameConfig";
            gameConfigNode.innerText = "配置";

            if (gameInfo.Peizhi == null
                || gameInfo.Peizhi == undefined
                || gameInfo.Peizhi.length == 0) 
            {
                gameConfigNode.className = "GameConfig None";
            }
            else
            {
                gameConfigNode.onclick = function ()
                {
                    var msg
                        = "GSApp://open.gameConfig.app?{\"gameId\":\"" + kGameId + "\"}";
                    GS.sendMessage(msg);
                }
            }

            var gameNameNode
                = document.createElement("div");
            {
                gameNameNode.className
                    = "GameName";

                if (gsIsCurrentOSAndroid() == true)
                {
                    gameNameNode.className
                        = "GameName Android";
                }
                gameNameNode.innerText
                    = gameInfo.Title;
                document.title
                    = gameInfo.Title;
            }
            gameInfoBarNode.appendChild(gameNameNode);

            var gameEnNameNode
                = document.createElement("div");
            {
                gameEnNameNode.className
                    = "GameEnName";
                gameEnNameNode.innerText
                    = gameInfo.EnTitle;
            }
            gameInfoBarNode.appendChild(gameEnNameNode);

            var gameSubIntroNode
                = document.createElement("div");
            gameSubIntroNode.className = "SubIntro";
            gameInfoBarNode.appendChild(gameSubIntroNode);

            var gamePlatformNode
                = document.createElement("div");
            {
                gamePlatformNode.className
                    = "GamePlatform";
            }
            gameSubIntroNode.appendChild(gamePlatformNode);

            if (gameInfo.platForms.length > 0) 
            {
                for (var index = 0; index < gameInfo.platForms.length; index++) 
                {
                    const platName = gameInfo.platForms[index];
                    var itemClassName = "GamePlatformItem" + platName;
                    var itemNode
                        = document.createElement("div");

                    itemNode.className
                        = itemClassName;

                    gamePlatformNode.appendChild(itemNode);
                }
            }
            else
            {
                var itemNode
                    = document.createElement("div");
                itemNode.className = "GamePlatformItemMobile";
                gamePlatformNode.appendChild(itemNode);
            }


            if (gameInfo.OfficialChinese == "1"
                || gameInfo.NsChinese == "1"
                || gameInfo.Ps4Chinese == "1"
                || gameInfo.XboxChinese == "1") 
            {
                var chinesNode
                    = document.createElement("div");
                chinesNode.className = "Chinese";
                chinesNode.innerText = "官方中文";
                gameSubIntroNode.appendChild(chinesNode);
            }

            ///游戏时长
            if (gameInfo.GameTime != null
                && gameInfo.GameTime.length > 0) 
            {
                var gameTimeNode
                    = document.createElement("div");
                gameTimeNode.className = "GameTime";

                gameTimeNode.innerText
                    = gameInfo.GameTime;

                gameSubIntroNode.appendChild(gameTimeNode);

                ///加一个换行元素
                var returnNode
                    = document.createElement("div");
                returnNode.style.clear = "both";
                returnNode.id = "gameInfo_Sub_Return";
                gameSubIntroNode.appendChild(returnNode);
            }

            var marketTimeNode
                = document.createElement("div");
            marketTimeNode.className = "MarketTime";
            if (gameInfo.GameTime != null
                && gameInfo.GameTime.length > 0) 
            {
                marketTimeNode.className = "MarketTime ContainGameTime";
            }
            var markTimeText = "未知";

            if (gameInfo.AllTime != null
                && gameInfo.AllTime != undefined
                && gameInfo.AllTime.length != 0) 
            {
                markTimeText
                    = gameInfo.AllTime;
            }

            if (markTimeText == "未知"
                && gameInfo.PCTime != null
                && gameInfo.PCTime != undefined
                && gameInfo.PCTime.length > 0
                && gameInfo.PCTime != "未知") 
            {
                markTimeText = gameInfo.PCTime;
            }
            if (markTimeText == "未知"
                && gameInfo.PS4Time != null
                && gameInfo.PS4Time != undefined
                && gameInfo.PS4Time.length > 0
                && gameInfo.PS4Time != "未知") 
            {
                markTimeText = gameInfo.PS4Time;
            }
            if (markTimeText == "未知"
                && gameInfo.XboxOneTime != null
                && gameInfo.XboxOneTime != undefined
                && gameInfo.XboxOneTime.length > 0
                && gameInfo.XboxOneTime != "未知") 
            {
                markTimeText = gameInfo.XboxOneTime;
            }
            if (markTimeText == "未知"
                && gameInfo.NintendoSwitchTime != null
                && gameInfo.NintendoSwitchTime != undefined
                && gameInfo.NintendoSwitchTime.length > 0
                && gameInfo.NintendoSwitchTime != "未知") 
            {
                markTimeText = gameInfo.NintendoSwitchTime;
            }


            if (markTimeText == "未知") 
            {
                marketTimeNode.innerText = "未知上市时间";
            }
            else
            {
                marketTimeNode.innerText
                    = GS.changeMarketTimeToShowing(markTimeText) + "上市";
            }

            gameSubIntroNode.appendChild(marketTimeNode);
            marketTimeNode.onclick = function ()
            {
                if (kGameInfo)
                {
                    var pcTime = null;
                    var psTime = null;
                    var xbTime = null;
                    var nsTime = null;
                    var ps5Time = null;
                    var xsxTime = null;

                    if (kGameInfo.PCTime != null
                        && kGameInfo.PCTime != undefined
                        && kGameInfo.PCTime.length > 0) 
                    {
                        if (kGameInfo.PCTime == "未知")
                        {
                            pcTime = "未知";
                        }
                        else
                        {
                            pcTime
                                = GS.changeMarketTimeToShowing(kGameInfo.PCTime);
                        }
                    }
                    if (kGameInfo.PS4Time != null
                        && kGameInfo.PS4Time != undefined
                        && kGameInfo.PS4Time.length > 0) 
                    {
                        if (kGameInfo.PS4Time == "未知")
                        {
                            psTime = "未知";
                        }
                        else
                        {
                            psTime
                                = GS.changeMarketTimeToShowing(kGameInfo.PS4Time);
                        }

                    }
                    if (kGameInfo.XboxOneTime != null
                        && kGameInfo.XboxOneTime != undefined
                        && kGameInfo.XboxOneTime.length > 0) 
                    {
                        if (kGameInfo.XboxOneTime == "未知")
                        {
                            xbTime = "未知";
                        }
                        else
                        {
                            xbTime
                                = GS.changeMarketTimeToShowing(kGameInfo.XboxOneTime);
                        }
                    }
                    if (kGameInfo.NintendoSwitchTime != null
                        && kGameInfo.NintendoSwitchTime != undefined
                        && kGameInfo.NintendoSwitchTime.length > 0) 
                    {
                        if (kGameInfo.NintendoSwitchTime == "未知")
                        {
                            nsTime = "未知";
                        }
                        else
                        {
                            nsTime
                                = GS.changeMarketTimeToShowing(kGameInfo.NintendoSwitchTime);
                        }
                    }

                    if (kGameInfo.PS5Time != null
                        && kGameInfo.PS5Time != undefined
                        && kGameInfo.PS5Time.length > 0) 
                    {
                        if (kGameInfo.PS5Time == "未知")
                        {
                            ps5Time = "未知";
                        }
                        else
                        {
                            ps5Time
                                = GS.changeMarketTimeToShowing(kGameInfo.PS5Time);
                        }

                    }
                    if (kGameInfo.XboxSeriesXTime != null
                        && kGameInfo.XboxSeriesXTime != undefined
                        && kGameInfo.XboxSeriesXTime.length > 0) 
                    {
                        if (kGameInfo.XboxSeriesXTime == "未知")
                        {
                            xsxTime = "未知";
                        }
                        else
                        {
                            xsxTime
                                = GS.changeMarketTimeToShowing(kGameInfo.XboxSeriesXTime);
                        }
                    }

                    var msg
                        = "{\"PC\":\""
                        + pcTime
                        + "\",\"PS4\":\""
                        + psTime
                        + "\",\"XBONE\":\""
                        + xbTime
                        + "\",\"NS\":\""
                        + nsTime
                        + "\",\"PS5\":\""
                        + ps5Time
                        + "\",\"XSX\":\""
                        + xsxTime
                        + "\"}";

                    msg
                        = "GSApp://show.marketTime.app?" + msg;

                    GS.sendMessage(msg);
                }
            };

            //游戏标签
            var tagsNode
                = document.createElement("div");
            tagsNode.className = "GameTags";
            tagsNode.style.width =
                gameInfoBarNode.appendChild(tagsNode);

            var tagsArray
                = gameInfo.gameTag;
            if (tagsArray != null
                && tagsArray != undefined
                && tagsArray.length > 0) 
            {
                if (tagsArray.length > 3)
                {
                    tagsArray
                        = tagsArray.slice(0, 3);
                }

                for (var index = 0; index < tagsArray.length; index++) 
                {
                    const tagCaption = tagsArray[index];
                    var tagItemNode
                        = document.createElement("span");
                    tagItemNode.innerText = tagCaption;
                    tagItemNode.className = "TagItem";
                    tagItemNode.id = tagCaption;
                    tagItemNode.setAttribute("onclick", "GS.openGameTag(\"" + tagCaption + "\")");
                    tagsNode.appendChild(tagItemNode);
                }

                var tagItems
                    = document.getElementsByClassName("TagItem");
                if (tagItems != null
                    && tagItems != undefined
                    && tagItems.length > 0)
                {
                    for (var index = 0; index < tagItems.length; index++) 
                    {
                        const tagItem = tagItems[index];

                        if (tagItem.offsetLeft + tagItem.offsetWidth > tagsNode.offsetWidth) 
                        {
                            tagItem.className = "TagItem None";
                        }
                    }
                }
            }
        }
    }

    GS.checkWhetherNeedToAutoLoadInWindow();
}
GS.openGameTag = function (gameTag) 
{
    GS.sendMessage("GSApp://open.gameTag.app?{\"tagName\":\"" + gameTag + "\"}");
}

///////////////////////////////
/// 4.5. 新增 - 加载游戏基础信息
///////////////////////////////
GS.addGameTrophyBar = function ()
{
    var trophyNode
        = document.createElement("div");
    trophyNode.id = "gameTrophy";
    GS.addElement(trophyNode);

    var msg
        = "GSApp://get.GameTrophy.app?{\"gameId\":\"" + kGameId + "\",\"callback\":\"GS.didGetGameTrophyInfos\"}";

    GS.sendMessage(msg);
}

GS.didGetGameTrophyInfos = function (response) 
{
    if (response.isGameHasPSNTrophy == true
        || response.isHasSteamArchievement == true) 
    {
        var trophyNode
            = document.getElementById("gameTrophy");

        trophyNode.className = "GameTrophy";

        var troInfos
            = document.createElement("div");
        troInfos.className = "Infos";
        trophyNode.appendChild(troInfos);

        var titleBar
            = document.createElement("div");
        titleBar.className = "TitleBar";
        troInfos.appendChild(titleBar);

        var title
            = document.createElement("div");
        title.className = "Title";
        title.innerText = "奖杯/成就";
        titleBar.appendChild(title);

        var arrow
            = document.createElement("div");
        arrow.className = "Arrow";
        titleBar.appendChild(arrow);

        var subTitle
            = document.createElement("div");
        subTitle.className = "SubTitle";
        subTitle.innerText = "点击查看游戏奖杯和成就数据";
        troInfos.appendChild(subTitle);

        var troIcon
            = document.createElement("div");
        troIcon.className = "Icon";
        trophyNode.appendChild(troIcon);

        trophyNode.onclick = function ()
        {
            var type = "PSN";
            if (response.isHasSteamArchievement == true)
            {
                if (response.isGameHasPSNTrophy == false)
                {
                    type = "Steam";
                }
            }

            var msg
                = "GSApp://open.GameTrophy.app?{\"gameId\":\"" + kGameId + "\",\"type\":\"" + type + "\"}";
            GS.sendMessage(msg);
        };
    }
}


///////////////////////////////
/// 5.加载游戏评分
///////////////////////////////
GS.addGameScore = function () 
{
    var gameScoreNode
        = document.createElement("div");
    gameScoreNode.id = "gameScore";
    GS.addElement(gameScoreNode);

    GS.getGameInfo("GS.getGameScoreAndCommentInfo");
}

var kGameInfo = null;
var kGameScore = null;
GS.getGameScoreAndCommentInfo = function (gameInfo) 
{
    kGameInfo
        = GS.transferGameInfoIntoContent(gameInfo);

    gsPostToURL("http://appapi2.gamersky.com/game/GetMyGameDetails",
        "POST",
        "{\"userId\":\"" + kUserId + "\",\"contentId\":\"" + kGameId + "\"}",
        true,
        false,
        "GS.checkUserScoresAndCommentDatas")
}
///检查用户评论评分数据有效性
GS.checkUserScoresAndCommentDatas = function (gameScoreJson) 
{
    var gameScore = null;
    if (gameScoreJson != null
        && gameScoreJson != undefined
        && gameScoreJson.length > 0) 
    {
        gameScore
            = JSON.parse(decodeURIComponent(gameScoreJson));

        if (gameScore != null
            && gameScore != undefined) 
        {

            if (gameScore.result != null
                && gameScore.result != undefined) 
            {
                gameScore
                    = gameScore.result;
            }

            kGameScore
                = gameScore;

            // if (kGameScore.myReviewID != null
            //     &&kGameScore.myReviewID != undefined
            //     &&kGameScore.myReviewID.length!=0
            //     &&Number(kGameScore.myReviewID)!=0) 
            // {
            // GS.createGameScoreChecking()
            // }
            // else
            // {
            GS.getUserCommentState();
            // }
        }
    }
}

//辅获取用户的评论状态,未登录状态区分
GS.getUserCommentState = function () 
{
    if (kUserId != null
        && kUserId != undefined
        && kUserId.length > 0) 
    {
        gsPostToURL("https://cm1.gamersky.com/apirating/getplatform?jsondata={\\\"GenneralId\\\":\\\"" + kGameId + "\\\"}&_=1567387184686",
            "GET",
            "",
            false,
            false,
            "GS.didGetUserCommentState");
    }
    else
    {
        setTimeout(function ()
        {
            GS.addGameScoreElement();
        }, 300);
    }
}

var kIsUserWantToPlay = false;  //用户是否想玩了
var kIsUserPlayed = false;      //用户是否玩过了
var kIsUserCommented = false;   //用户是否写了评论
var kIsUserScored = false;      //用户是否打分了

var kPlayState = 0;             //用户想玩玩过状态.传值用

GS.didGetUserCommentState = function (response) 
{
    var userLike = null;

    try
    {
        if (response != null
            && response != undefined
            && response.length > 0) 
        {
            var responseOrigin = decodeURIComponent(response);
            if (responseOrigin.indexOf("(") != -1) 
            {
                responseOrigin
                    = String(responseOrigin).replace("(", "");
            }
            if (responseOrigin.indexOf(");") != -1) 
            {
                responseOrigin
                    = String(responseOrigin).replace(");", "");
            }

            var responseJson
                = JSON.parse(responseOrigin);
            if (responseJson != null
                && responseJson != undefined) 
            {
                var stateResult
                    = responseJson;
                var resultJson = null;
                if (stateResult.result != null
                    && stateResult.result != undefined) 
                {
                    resultJson
                        = JSON.parse(stateResult.result);
                }
                else
                {
                    resultJson = stateResult;
                }

                if (resultJson.status == "ok") 
                {
                    if (resultJson.played == true) 
                    {
                        kIsUserPlayed = true;
                        kPlayState = 2;
                    }
                    if (resultJson.wanplay == true) 
                    {
                        kIsUserWantToPlay = true;
                        kPlayState = 1;
                    }
                    if (resultJson.isComment == true) 
                    {
                        kIsUserCommented = true;
                    }
                    if (resultJson.grade == true) 
                    {
                        kIsUserScored = true;
                    }
                }
            }
        }
    }
    catch (error)
    {
        console.log("评论状态解析错误");
    }


    if (kIsUserCommented) 
    {
        GS.createGameScoreChecking();
    }
    else
    {
        var userLike
            = "{\"commentContent\":\"" + ((kGameScore.myReview == null || kGameScore.myReview == undefined) ? "" : kGameScore.myReview) + "\",\"commentPlayedState\":" + kPlayState + ",\"commentScore\":\"" + kGameScore.myScore + "\",\"commentId\":\"\"}";

        setTimeout(function ()
        {
            GS.addGameScoreElement(userLike);
        }, 300);
    }

}

GS.createGameScoreChecking = function (gameScore) 
{
    if (kUserId != null
        && kUserId != undefined
        && Number(kUserId) != 0)
    {
        gsPostToURL("http://appapi2.gamersky.com/v4/getGameUserComment",
            "POST",
            "{\"gameId\": \"" + kGameId + "\",\"userId\":\"" + kUserId + "\",\"gameModeFieldNames\":\"\",\"gameRelatedFieldNames\":\"\"}",
            true,
            false,
            "GS.addGameScoreElement");
    }
    else
    {
        setTimeout(function ()
        {
            GS.addGameScoreElement();
        }, 300);
    }
}

var kGameCommentContent = null;
GS.addGameScoreElement = function (userLikeStateJson) 
{
    var gameScore = kGameScore;

    if (gameScore != null
        && gameScore != undefined) 
    {
        var gameScoreNode
            = document.getElementById("gameScore");
        gameScoreNode.className = "GameScore";

        var ratioNode
            = document.createElement("div");
        gameScoreNode.appendChild(ratioNode);
        ratioNode.className = "Ratio";;

        if (kGameInfo.isMarketed)
        {
            //////左侧评分部分
            var scoreNode
                = document.createElement("div");
            ratioNode.appendChild(scoreNode);

            if (Number(kGameInfo.gsScore) != 0) 
            {
                scoreNode.className = "Score";
                scoreNode.innerText = parseFloat(kGameInfo.gsScore).toFixed(1);
                var starNode
                    = GS.addScoreStarsElement("Ratio", kGameInfo.gsScore);
                ratioNode.appendChild(starNode);
            }
            else
            {
                //评分人数不足
                scoreNode.className = "NoneScore";
                scoreNode.innerText = "评分人数不足";
                gameScoreNode.className = "GameScore NoneScore";
            }

            var scoreRatioNode
                = document.createElement("div");
            ratioNode.appendChild(scoreRatioNode);
            scoreRatioNode.className = "Percentage";
            if (Number(kGameInfo.gsScore) == 0) 
            {
                scoreRatioNode.className = "Percentage NoScore";
            }


            var gameScoreResult = null;
            if (gameScore.result != null
                && gameScore.result != undefined) 
            {
                if (gameScore.errorCode != null
                    && gameScore.errorCode != undefined) 
                {
                    if (gameScore.errorCode == 0) 
                    {
                        gameScoreResult
                            = gameScore.result;
                    }
                }
            }
            else
            {
                if (gameScore != null
                    && gameScore != undefined) 
                {
                    gameScoreResult = gameScore;
                }
            }


            var scoreDist
                = gameScoreResult.userScoreDist;

            for (var index = scoreDist.length - 1; index >= 0; index--) 
            {
                const scoreElement = scoreDist[index];

                var scoreDistNode
                    = document.createElement("div");
                scoreRatioNode.appendChild(scoreDistNode);
                scoreDistNode.className = "Dist";

                var scoreTitle
                    = document.createElement("span");
                scoreDistNode.appendChild(scoreTitle);
                scoreTitle.className = "ScoreTitle";
                scoreTitle.innerText = parseInt(scoreElement.level / 2) + "星";

                var scorePro
                    = document.createElement("span");
                scoreDistNode.appendChild(scorePro);
                scorePro.className = "ScorePro";

                var scoreProUp
                    = document.createElement("i");
                scoreProUp.className = "Inner";
                scorePro.appendChild(scoreProUp);
                if (Number(kGameInfo.gsScore) != 0) 
                {
                    scoreProUp.style.width = scorePro.offsetWidth * scoreElement.ratio / 100 + "px";
                }
                else
                {
                    scoreProUp.style.width = 0 + "px";
                }

                var scoreRatioSet
                    = document.createElement("span");
                scoreDistNode.appendChild(scoreRatioSet);
                scoreRatioSet.className = "RationSet";
                scoreRatioSet.innerText = Math.round(scoreElement.ratio) + "%";

                if (Number(kGameInfo.gsScore) == 0) 
                {
                    scoreProUp.className = "Inner None";
                    scoreRatioSet.innerText = "0%";
                }
            }
        }

        var commentNode
            = document.createElement("div");
        gameScoreNode.appendChild(commentNode);
        commentNode.className = "CommentPart";

        ////右侧评论部分
        var commentMore
            = document.createElement("div");
        commentMore.className = "More";
        commentNode.appendChild(commentMore);

        var totalCommentsNode
            = document.createElement("div");
        totalCommentsNode.id = "GS_TotalCommentCount"
        totalCommentsNode.className = "TotalCommentCount";
        totalCommentsNode.innerText = "--人评分";

        totalCommentsNode.onclick = function () 
        {
            var msg
                = "GSApp://open.gameComment.app?{\"gameId\":\"" + kGameId + "\",\"gameName\":\"" + kGameInfo.Title + "\",\"isMarketed\":\"" + kGameInfo.isMarketed + "\",\"steamId\":\"" + kGameInfo.SteamId + "\",\"operate\":\"allComments\"}";
            GS.sendMessage(msg);
        }

        commentNode.appendChild(totalCommentsNode);

        gsPostToURL("https://cm1.gamersky.com/apirating/getplayersscore?jsondata={\\\"genneralId\\\":\\\"" + kGameId + "\\\"}&_=1567387184686",
            "GET",
            "",
            false,
            false,
            "GS.didGetCommentCount");

        var playedCountNode
            = document.createElement("div");
        playedCountNode.className = "PlayedCount";
        playedCountNode.innerText
            = kGameInfo.playCount
            + "人玩过，"
            + kGameInfo.expectCount
            + "人想玩";

        playedCountNode.onclick = function () 
        {
            var msg
                = "GSApp://open.gameComment.app?{\"gameId\":\"" + kGameId + "\",\"gameName\":\"" + kGameInfo.Title + "\",\"isMarketed\":\"" + kGameInfo.isMarketed + "\",\"steamId\":\"" + kGameInfo.SteamId + "\",\"operate\":\"allComments\"}";
            GS.sendMessage(msg);
        }

        commentNode.appendChild(playedCountNode);

        var myGameCommentId = kGameScore.myReviewID.toString();
        if (myGameCommentId == null
            || myGameCommentId == undefined
            || myGameCommentId.length == 0)
        {
            myGameCommentId = "";
        }
        if (userLikeStateJson != null
            && userLikeStateJson != undefined
            && userLikeStateJson != "null") 
        {
            var userLike
                = JSON.parse(decodeURIComponent(userLikeStateJson));

            GS.createUserCommentsStateOperateButtons(userLike.commentContent, userLike.commentPlayedState, userLike.commentScore, myGameCommentId);
        }
        else
        {
            GS.createUserCommentsStateOperateButtons("", 0, 0, "");
        }
    }

    GS.checkWhetherNeedToAutoLoadInWindow();
}

GS.didGetCommentCount = function (response)
{
    var userLike = null;

    try
    {
        if (response != null
            && response != undefined
            && response.length > 0)
        {
            var responseOrigin = decodeURIComponent(response);
            if (responseOrigin.indexOf("(") != -1)
            {
                responseOrigin
                    = String(responseOrigin).replace("(", "");
            }
            if (responseOrigin.indexOf(");") != -1)
            {
                responseOrigin
                    = String(responseOrigin).replace(");", "");
            }

            var responseJson
                = JSON.parse(responseOrigin);
            if (responseJson != null
                && responseJson != undefined)
            {
                var stateResult
                    = responseJson;
                var resultJson = null;
                if (stateResult.result != null
                    && stateResult.result != undefined)
                {
                    resultJson
                        = JSON.parse(stateResult.result);
                }
                else
                {
                    resultJson = stateResult;
                }

                var totalCommentCountNode = document.getElementById("GS_TotalCommentCount");
                if (totalCommentCountNode)
                {
                    var count = resultJson.timesRandom ? resultJson.timesRandom : "0";
                    totalCommentCountNode.innerText = count + "人评分";
                }
            }
        }
    }
    catch (error)
    {
        console.log("评论状态解析错误");
    }
}

GS.createUserCommentsStateOperateButtons = function (commentContent, playState, score, commentId)
{
    var commentNode
        = document.getElementsByClassName("CommentPart")[0];

    if (commentContent != null
        && commentContent != undefined
        && commentContent.length > 0) 
    {
        kGameCommentContent
            = commentContent;
    }
    else
    {
        kGameCommentContent = "";
    }

    var isLogined
        = (kUserId != null && kUserId != undefined && Number(kUserId) != 0);

    var wantPlayButton = document.createElement("div");
    wantPlayButton.id = "wantToPlay";
    wantPlayButton.className = "PlayOperateButton WantPlayButton";
    if (gsIsCurrentOSAndroid() == true) 
    {
        wantPlayButton.className = "PlayOperateButton Android WantPlayButton"
    }
    commentNode.appendChild(wantPlayButton);

    var wantPlayInner = document.createElement("div");
    wantPlayInner.className = "WantToPlay";
    wantPlayInner.id = "wantToPlay_Inner";
    wantPlayInner.innerText = "想玩";
    wantPlayButton.appendChild(wantPlayInner);

    var playedButton = document.createElement("div");
    playedButton.id = "played";
    playedButton.className = "PlayOperateButton PlayedButton";
    if (gsIsCurrentOSAndroid() == true)
    {
        playedButton.className = "PlayOperateButton Android PlayedButton"
    }
    commentNode.appendChild(playedButton);

    var playedInner = document.createElement("div");
    playedInner.className = "Played";
    playedInner.id = "played_Inner";
    playedInner.innerText = "玩过";
    playedButton.appendChild(playedInner);

    var wantIcon = document.createElement("div");
    wantIcon.id = "wantIcon";
    wantIcon.className = "WantIcon";

    var playedIcon
        = document.createElement("div");
    playedIcon.id = "playedIcon";
    playedIcon.className = "PlayedIcon";

    var wantMore
        = document.createElement("div");
    wantMore.id = "wantMore";
    wantMore.className = "WantMore";

    var playedMore
        = document.createElement("div");
    playedMore.id = "playedMore";
    playedMore.className = "WantMore";

    var isPlayedByUser = false;
    var isWantPlayByUser = false;

    if (kGameInfo.isMarketed) 
    {
        // playState  0 没选过  1 期待/想玩  2 玩过

        if (playState == 0
            || playState == undefined
            || playState == null) 
        {
            wantPlayButton.insertBefore(wantIcon, wantPlayInner);
            playedButton.insertBefore(playedIcon, playedInner);
        }
        else
        {
            if (playState != null
                && playState != undefined) 
            {
                if (Number(playState) == 0) 
                {
                    wantPlayButton.insertBefore(wantIcon, wantPlayInner);
                    playedButton.insertBefore(playedIcon, playedInner);
                }

                if (isLogined == true) 
                {
                    if (Number(playState) == 1)
                    {
                        wantPlayInner.innerText = "已想玩";
                        wantPlayButton.appendChild(wantMore);
                        {
                            var className = "";
                            var operName = "PlayOperateButton WantPlayButton ";
                            if (gsIsCurrentOSAndroid() == true)
                            {
                                operName = "PlayOperateButton Android WantPlayButton ";
                            }
                            wantPlayButton.className
                                = operName
                                + className
                                + "WantToPlay";
                        }
                        playedButton.insertBefore(playedIcon, playedInner);

                        // !!!
                        isWantPlayByUser = true;
                        // !!!
                    }
                    else if (Number(playState) == 2)
                    {
                        wantPlayButton.parentNode.removeChild(wantPlayButton);

                        var className = "";
                        var operName = "PlayOperateButton PlayedButton ";
                        if (gsIsCurrentOSAndroid() == true)
                        {
                            operName = "PlayOperateButton Android PlayedButton ";
                        }
                        playedButton.className
                            = operName
                            + className
                            + "Played";

                        var stars
                            = GS.addScoreStarsElement("InPlayed", score);

                        playedButton.appendChild(stars);
                        playedInner.innerText = "已玩过";
                        playedMore.className = "WantMore Played";
                        playedButton.appendChild(playedMore);
                        //
                        isPlayedByUser = true;
                        //

                        // !!!
                        isPlayedByUser = true;
                        // !!!
                    }
                }
            }
            else
            {
                wantPlayButton.insertBefore(wantIcon, wantPlayInner);
                playedButton.insertBefore(playedIcon, playedInner);
            }
        }
    }
    else
    {
        ///期待状态
        var gameScoreNode
            = document.getElementById("gameScore");

        var raioNode = null;
        var ratioNodes
            = document.getElementsByClassName("Ratio");
        if (ratioNodes != null
            && ratioNodes != undefined
            && ratioNodes.length > 0) 
        {
            ratioNode
                = ratioNodes[0];
        }

        gameScoreNode.insertBefore(ratioNode, commentNode);

        gameScoreNode.className = "GameScore Expected";
        ratioNode.className = "Ratio Expected";
        ratioNode.removeAllChild();
        commentNode.removeAllChild();

        var expectCountsNode
            = document.createElement("div");

        expectCountsNode.className
            = "TotalCommentCount Expected";
        expectCountsNode.innerText = kGameInfo.expectCount + "人期待";
        ratioNode.appendChild(expectCountsNode);

        var expectTipNode
            = document.createElement("div");
        expectTipNode.className = "PlayedCount Expected";
        expectTipNode.innerText = "游戏暂未上市";
        ratioNode.appendChild(expectTipNode);

        commentNode.className = "CommentPart Expected";

        wantPlayButton.className
            = "PlayOperateButton ExpectedButton";

        if (gsIsCurrentOSAndroid() == true) 
        {
            wantPlayButton.className
                = "PlayOperateButton Android ExpectedButton";
        }

        wantPlayButton.insertBefore(wantIcon, wantPlayInner);
        wantPlayInner.innerText = "期待";
        commentNode.appendChild(wantPlayButton);
        if (Number(playState) == 1)
        {
            ///已期待状态
            wantPlayButton.className
                = "PlayOperateButton ExpectedButton Expected";
            if (gsIsCurrentOSAndroid() == true) 
            {
                wantPlayButton.className
                    = "PlayOperateButton Android ExpectedButton Expected";
            }
            wantPlayButton.removeAllChild();

            var wantNode
                = document.createElement("div");
            wantNode.className = "WantToPlay";
            wantNode.id = "wantToPlay_Inner";
            wantNode.innerText = "已期待";
            wantPlayButton.appendChild(wantNode);
            //
            isWantPlayByUser = true;
            //

            var expectedMore
                = document.createElement("div");
            expectedMore.className = "WantMore Expected";
            wantPlayButton.appendChild(expectedMore);
        }
    }

    ///两个按钮的点击事件
    // playState  0 没选过  1 期待/想玩  2 玩过
    wantPlayButton.onclick = function ()
    {
        if (commentContent != null
            && commentContent != undefined
            && commentContent.length > 0
            && commentId != null
            && commentId != undefined
            && commentId.length > 0
            && !isNaN(Number(commentId))
            && Number(commentId) != 0
            && Number(playState) == 1)
        {
            var msg
                = "GSApp://open.gameComment.app?{\"gameId\":\"" + kGameId
                + "\",\"gameName\":\"" + kGameInfo.Title
                + "\",\"commentId\":\"" + commentId
                + "\",\"userId\":\"" + kUserId
                + "\",\"userName\":\"" + ""
                + "\",\"commentContent\":\"" + commentContent
                + "\",\"operate\":\"commentDetail\"}";

            GS.sendMessage(msg);
        }
        else
        {
            GS.createCommentStateElement(kGameCommentContent, "wantPlay", score, commentId, isWantPlayByUser);
        }

    };

    playedButton.onclick = function () 
    {
        if (commentContent != null
            && commentContent != undefined
            && commentContent.length > 0
            && commentId != null
            && commentId != undefined
            && commentId.length > 0
            && !isNaN(Number(commentId))
            && Number(commentId) != 0
            && Number(playState) == 2)
        {
            var msg
                = "GSApp://open.gameComment.app?{\"gameId\":\"" + kGameId
                + "\",\"gameName\":\"" + kGameInfo.Title
                + "\",\"commentId\":\"" + commentId
                + "\",\"userId\":\"" + kUserId
                + "\",\"userName\":\"" + ""
                + "\",\"commentContent\":\"" + commentContent
                + "\",\"operate\":\"commentDetail\"}";

            GS.sendMessage(msg);
        }
        else
        {
            GS.createCommentStateElement(kGameCommentContent, "played", score, commentId, isPlayedByUser);
        }
    };
}

GS.createCommentStateElement = function (commentContent, playState, score, commentId, isPlayStateByUser)
{
    var msg
        = "GSApp://create.gameComment.app?{\"gameId\":\"" + kGameId + "\",\"commentId\":\"" + commentId + "\","
        + "\"commentContent\":\"" + ((commentContent != null && commentContent != undefined) ? commentContent : "") + "\","
        + "\"playState\":\"" + ((playState != null && playState != undefined) ? playState : "") + "\","
        + "\"isPlayStateByUser\":" + isPlayStateByUser + ","
        + "\"score\":\"" + ((score != null && score != undefined) ? score : "0") + "\","
        + "\"isMarketed\":\"" + kGameInfo.isMarketed + "\","
        + "\"callback\":\"GS.didCommentStateElementCreated\"}";
    {
        console.log(msg);
    }
    GS.sendMessage(msg);
}

GS.didCommentStateElementCreated = function (commentContent, playState, score) 
{
    if (commentContent == null)
    {
        commentContent = "";
        playState = 0;
        score = 0;
    }
    else if (typeof (commentContent) == "string") 
    {
        kGameCommentContent = commentContent;
    }
    else if (typeof (commentContent) == "object")
    {
        if (commentContent.userId != undefined)
        {
            kUserId = commentContent.userId;
        }

        kGameCommentContent = commentContent.commentContent;

        playState = commentContent.playState;
        score = commentContent.score;
        // !!!
        commentContent = commentContent.commentContent;
        // !!!
    }
    ///去掉原有的所有按钮 增加新按钮和独立样式

    // playState  0 没选过  1 期待/想玩 wantPlay 2 玩过 played

    var operateButtons
        = document.getElementsByClassName("PlayOperateButton");
    if (operateButtons != null
        && operateButtons != undefined
        && operateButtons.length > 0) 
    {
        for (var index = operateButtons.length - 1; index >= 0; index--) 
        {
            const element = operateButtons[index];

            if (element.parentNode != null
                && element.parentNode != undefined) 
            {
                element.parentNode.removeChild(element);
            }
        }
    }

    if (playState == "wantPlay"
        || playState == "expected")
    {
        playState = 1;
    }
    else if (playState == "played")
    {
        playState = 2;
    }
    else
    {
        playState = 0;
    }
    ///!!!
    GS.createUserCommentsStateOperateButtons(kGameCommentContent, playState, score);
    ///!!!
}

//****用户相关****/
/*{
	userId;
	userName;
	userHeadImageURL;
	userLevel;
	userGroupId;
	userSubtitle;
	userScore;
	userPlayState;
	userPlayform;
    userPlayedPlatform;
    userThirdPlatformBound;
    isUserRealPlayer
}*/
GS.addUserInfoBar = function (userInfo) 
{
    var userInfoBar
        = document.createElement("div");
    userInfoBar.className = "UserInfoBar";

    var userHeadNode
        = document.createElement("div");
    userHeadNode.className = "UserHead";
    userInfoBar.appendChild(userHeadNode);
    userHeadNode.setAttribute("src", userInfo.userHeadImageURL);
    if (userInfo.userHeadImageURL != null
        && userInfo.userHeadImageURL != undefined
        && userInfo.userHeadImageURL.length != 0) 
    {
        userHeadNode.style.background = "url(" + userInfo.userHeadImageURL + ")";
    }

    userHeadNode.style.backgroundSize = "cover";

    var authentic = null;
    if (userInfo.userGroupId == 6) 
    {
        authentic
            = document.createElement("div");
        authentic.className = "AuthenticBlue";
    }
    else if (userInfo.userGroupId == 9
        || userInfo.userGroupId == 10
        || userInfo.userGroupId == 12
        || userInfo.userGroupId == 13)
    {
        authentic
            = document.createElement("div");
        authentic.className = "AuthenticPurple";
    }
    else
    {

    }
    if (authentic != null) 
    {
        userHeadNode.appendChild(authentic);
    }

    var userNamePart
        = document.createElement("div");
    userNamePart.className = "UserNamePart";
    userInfoBar.appendChild(userNamePart);

    var userNameNode
        = document.createElement("div");
    userNameNode.className = "UserName";
    if (gsIsCurrentOSAndroid() == true) 
    {
        userNameNode.className = "UserName Android";
    }
    userNamePart.appendChild(userNameNode);
    userNameNode.innerText = userInfo.userName;

    var userBindingNode
        = document.createElement("div");
    userBindingNode.className = "ThirdPlatform None";
    userNamePart.appendChild(userBindingNode);
    userBindingNode.style.display = "none";
    {
        if (userInfo.userThirdPlatformBound != null
            && userInfo.userThirdPlatformBound != undefined)
        {
            var boundInfo = userInfo.userThirdPlatformBound;
            var steam = false;
            var psn = false;
            var xbox = false;

            var boundClass = null;
            if (boundInfo.indexOf("steam") != -1) 
            {
                steam = true;
                boundClass = "ThirdPlatform Steam";
            }
            if (boundInfo.indexOf("psn") != -1) 
            {
                psn = true;
                boundClass = "ThirdPlatform PSN";
            }
            if (boundInfo.indexOf("xbox") != -1) 
            {
                xbox = true;
                boundClass = "ThirdPlatform XBox";
            }

            if (steam == true
                && psn == true
                && xbox == true) 
            {
                boundClass = "ThirdPlatform SteamPSNAndXBox";
            }
            else if (steam == true
                && psn == true)
            {
                boundClass = "ThirdPlatform SteamAndPSN";
            }
            else if (steam == true
                && xbox == true)
            {
                boundClass = "ThirdPlatform SteamAndXBox";
            }
            else if (psn == true
                && xbox == true)
            {
                boundClass = "ThirdPlatform PSNAndXBox";
            }
            userBindingNode.style.visibility = "visible";
            userBindingNode.className = boundClass;
        }
    }

    if (userInfo.isUserRealPlayer == true)
    {
        var isRealUserNode
            = document.createElement("div");
        isRealUserNode.className = "RealPlayer";
        userNamePart.appendChild(isRealUserNode);
    }

    var userLevelNode
        = document.createElement("div");
    userLevelNode.className = "UserLevel";
    userNamePart.appendChild(userLevelNode);
    userLevelNode.innerText = "Lv" + userInfo.userLevel;

    var userSubtitlePart
        = document.createElement("div");
    userSubtitlePart.className = "UserSubPart";
    userInfoBar.appendChild(userSubtitlePart);

    var subTitleNode
        = document.createElement("div");
    subTitleNode.className = "PlayState";
    userSubtitlePart.appendChild(subTitleNode);

    if (userInfo.userSubtitle != null
        && userInfo.userSubtitle != undefined
        && userInfo.userSubtitle.length > 0) 
    {
        if (userInfo.userPlayState != null
            && userInfo.userPlayState != undefined
            && userInfo.userPlayState != 0) 
        {
            if (userInfo.userPlayState == 1)
            {
                subTitleNode.innerText = "玩过";
                if (userInfo.userScore != null
                    && userInfo.userScore != undefined
                    && userInfo.userScore > 0) 
                {
                    var starNode
                        = GS.addScoreStarsElement("InComment", userInfo.userScore);
                    userSubtitlePart.insertBefore(starNode, subTitleNode);
                }
            }
            else if (userInfo.userPlayState == 2)
            {
                subTitleNode.innerText = "想玩";
            }
            else if (userInfo.userPlayState == -1)
            {
                subTitleNode.innerText = "期待";
            }
            else
            {

            }
        }
    }
    if (userInfo.userId != null
        && userInfo.userId != undefined
        && userInfo.userId.length > 0) 
    {
        userInfoBar.onclick = function ()
        {
            var realPlayNode
                = event.target;
            if (realPlayNode.className != "RealPlayer") 
            {
                GS.openUserInfo(userInfo.userId);
            }
            else
            {
                //真玩家图标点击
                ///弹出图片,2s后隐藏

                var rpTip
                    = document.createElement("div");
                rpTip.className = "RealPlayerTip";

                ///在屏幕中的相对位置
                var left
                    = realPlayNode.offsetLeft + realPlayNode.offsetWidth / 2.0 - 106;
                var top
                    = realPlayNode.offsetTop + realPlayNode.offsetHeight - window.scrollY;
                rpTip.style.left
                    = left;
                rpTip.style.top
                    = top;

                document.body.appendChild(rpTip);

                setTimeout(
                    function ()
                    {
                        rpTip.parentNode.removeChild(rpTip);
                    }, 2000
                );
            }
        };
    }
    return userInfoBar;
}
//action
GS.openUserInfo = function (userId) 
{
    if (userId != null
        && userId != undefined
        && userId.length > 0) 
    {
        GS.sendMessage("GSApp://open.user.app?{\"userId\":\"" + userId + "\"}");
    }
}

///////////////////////////////
/// 6.游戏简介
///////////////////////////////
GS.addGameIntro = function () 
{
    var gameIntro
        = document.createElement("div");
    gameIntro.id = "gameIntro";
    gameIntro.className = "Loading";
    GS.addElement(gameIntro);

    setTimeout(
        function () 
        {
            if (kGameInfo != null
                && kGameInfo != undefined)
            {
                GS.addGameIntroElement();
            }
            else
            {
                GS.getGameInfo("GS.addGameIntroElement");
            }
        }, 300);

}
GS.addGameIntroElement = function (gameInfos) 
{
    if (gameInfos != null
        && gameInfos != undefined) 
    {
        kGameInfo
            = GS.transferGameInfoIntoContent(gameInfos);
    }

    var gameIntroNode
        = document.getElementById("gameIntro");
    gameIntroNode.className = "GameIntro";
    gameIntroNode.innerText = "";

    var introTitle
        = document.createElement("div");
    gameIntroNode.appendChild(introTitle);
    introTitle.className = "Title";

    if (gsIsCurrentOSAndroid() == true) 
    {
        introTitle.className = "Title Android";
    }
    introTitle.innerText = "简介";

    var introInfo
        = document.createElement("div");
    gameIntroNode.appendChild(introInfo);
    introInfo.className = "Info";
    {

    }
    var gameIntroOriginalText
        = kGameInfo.Intro.replaceAll("　", "").replaceAll(" ", "").replaceReturn().toPureString();
    var gameIntroMaxLength = 90;
    if (window.screen.width == 414)
    {
        gameIntroMaxLength = 108;
    }
    introInfo.innerHTML
        = GSApp.UIControls.textToHtmlWithExpandButtonInMaxLength(
            gameIntroOriginalText,
            gameIntroMaxLength,
            "详情",
            "");

    /*
var more
    = document.createElement("div");

if (gsIsCurrentOSAndroid() == true) 
{
    more.className = "More Android";
}
else
{
    more.className = "More";
}
gameIntroNode.appendChild(more);
more.innerText = "详情";
*/

    introInfo.onclick = function ()
    {
        GS.openGameIntro();
    }

    // more.onclick = function ()
    // {
    //     GS.openGameIntro();
    // }

    ///!!!!
    GS.checkWhetherNeedToAutoLoadInWindow();
}

GS.openGameIntro = function ()
{
    var msg
        = "GSApp://open.gameIntro.app?{\"gameId\":\"" + kGameId + "\"}";

    GS.sendMessage(msg);
}

///////////////////////////////
/// 7.媒体评分
///////////////////////////////
GS.addMediaScores = function () 
{
    var mediaScoreNode
        = document.createElement("div");
    mediaScoreNode.id = "mediaScore";
    GS.addElement(mediaScoreNode);

    gsPostToURL("http://appapi2.gamersky.com/game/GameMediaRating",
        "POST",
        "{\"contentId\":\"" + kGameId + "\"}",
        true,
        true,
        "GS.addMediaScoreElements");
};
GS.addAMediaScoreItemElement = function (score) 
{
    if (score != null
        && score != undefined) 
    {
        var itemNode
            = document.createElement("div");
        itemNode.className = "MediaScoreItem";

        var scoreNode
            = document.createElement("div");
        scoreNode.className = "Score";

        if (gsIsCurrentOSAndroid() == true) 
        {
            scoreNode.className = "Score Android";
        }
        itemNode.appendChild(scoreNode);
        scoreNode.innerText = score.mediaScore;

        var totalScoreNode
            = document.createElement("div");
        totalScoreNode.className = "TotalScore";
        itemNode.appendChild(totalScoreNode);
        totalScoreNode.innerText = score.totalScore;

        var mediaNameNode
            = document.createElement("div");
        mediaNameNode.className = "MediaName";
        itemNode.appendChild(mediaNameNode);
        mediaNameNode.innerText = score.mediaName;

        var i = 0;
        while (mediaNameNode.offsetWidth > 84)
        {
            mediaNameNode.style.fontSize = (14 - i) + "px";
            i++
        }

        link = score.contentURL;
        if (link != null
            && link != undefined
            && link.length > 0) 
        {
            var linkNode
                = document.createElement("div");
            linkNode.className = "Link";
            itemNode.appendChild(linkNode);
            itemNode.setAttribute("link", link);
            itemNode.onclick = function ()
            {
                GS.sendMessage("GSApp://open.url.app?{\"url\":\"" + score.contentURL + "\"}");
            };
        }
        return itemNode;
    }
}
GS.addMediaScoreElements = function (response) 
{
    var scores = null;

    if (response != null
        && response != undefined
        && response.length > 0) 
    {
        var responseJson
            = JSON.parse(decodeURIComponent(response));

        if (responseJson != null
            && responseJson != undefined) 
        {
            if (responseJson.result != null
                && responseJson.result != undefined) 
            {
                if (responseJson.errorCode != null
                    && responseJson.errorCode != undefined) 
                {
                    if (Number(responseJson.errorCode) == 0) 
                    {
                        if (responseJson.result != null
                            && responseJson.result != undefined) 
                        {
                            var scoresResult = responseJson.result;
                            if (scoresResult.result != null
                                && scoresResult.result != undefined) 
                            {
                                scores = scoresResult.result;
                            }
                            else
                            {
                                scores = scoresResult;
                            }
                        }
                    }
                }
            }
            else
            {
                scores = responseJson;
            }
        }

        if (scores != null
            && scores != undefined
            && scores.length > 0) 
        {
            var mediaScoreNode
                = document.getElementById("mediaScore");
            mediaScoreNode.className = "MediaScore";

            var mediaTitleNode
                = document.createElement("div");
            mediaTitleNode.innerText = "媒体评分";
            mediaTitleNode.className = "Title";
            if (gsIsCurrentOSAndroid() == true) 
            {
                mediaTitleNode.className = "Title Android";
            }
            mediaScoreNode.appendChild(mediaTitleNode);

            var mediaScrollBox
                = document.createElement("div");
            mediaScrollBox.className = "MediaScrollBox";
            mediaScoreNode.appendChild(mediaScrollBox);

            var mediaScrollView
                = document.createElement("div");
            mediaScrollView.className = "MediaScrollView";
            mediaScrollBox.appendChild(mediaScrollView);

            for (var index = 0; index < scores.length; index++) 
            {
                const scoreSet = scores[index];
                var itemNode
                    = GS.addAMediaScoreItemElement(scoreSet);
                itemNode.id = "mediaScore_" + index;
                if (index == 0) 
                {
                    itemNode.style.marginLeft = "16px";
                }
                mediaScrollView.appendChild(itemNode);
            }

            mediaScrollView.style.width
                = (107 + 16) * (scores.length) + 16 + "px";
        }
        else
        {

        }
    }

    GS.checkWhetherNeedToAutoLoadInWindow();

    // 注册可滑动区域：

    if (gsIsCurrentOSAndroid())
    {

        setTimeout(function () 
        {
            var mediaSliderScrollViewArea = "";
            var mediaSliderScrollViews
                = document.getElementsByClassName("MediaSliderScrollView");
            if (mediaSliderScrollViews != null
                && mediaSliderScrollViews.length > 0)
            {
                var mediaSliderScrollView = mediaSliderScrollViews[0];

                mediaSliderScrollViewArea
                    = "["
                    + mediaSliderScrollView.offsetLeft + ", "
                    + mediaSliderScrollView.offsetTop + ", "
                    + mediaSliderScrollView.offsetWidth + ", "
                    + mediaSliderScrollView.offsetHeight + "]"
            }

            var mediaScrollBoxArea = "";
            var mediaScrollBoxs
                = document.getElementsByClassName("MediaScrollView");
            if (mediaScrollBoxs != null
                && mediaScrollBoxs.length > 0)
            {
                var mediaScrollBox = mediaScrollBoxs[0];

                mediaScrollBoxArea
                    = "["
                    + mediaScrollBox.offsetLeft + ", "
                    + mediaScrollBox.offsetTop + ", "
                    + mediaScrollBox.offsetWidth + ", "
                    + mediaScrollBox.offsetHeight + "]"
            }

            var invalidAreas = "";
            if (mediaSliderScrollViewArea.length > 0
                && mediaScrollBoxArea.length > 0)
            {
                invalidAreas
                    = mediaSliderScrollViewArea + ", " + mediaScrollBoxArea;
            }
            else if (mediaSliderScrollViewArea.length > 0)
            {
                invalidAreas
                    = mediaSliderScrollViewArea;
            }
            else if (mediaScrollBoxArea.length > 0)
            {
                invalidAreas
                    = mediaScrollBoxArea;
            }

            if (invalidAreas.length > 0)
            {
                var cmdToRegisterInvalidAreaGesture
                    = "gsapp://invalidArea.gesture.app?{\"areas\": ["
                    + invalidAreas
                    + "]}";
                // !!!
                GS.sendMessage(cmdToRegisterInvalidAreaGesture);
                // !!!
            }
        },
            300);
    }
}

///////////////////////////////
/// 8.玩家点评
///////////////////////////////
GS.addUserGameComments = function () 
{
    var userComments
        = document.createElement("div");
    userComments.id = "userComments";
    userComments.className = "Loading";
    // userComments.innerText = "加载中..."
    GS.addElement(userComments);

    var loadType = 0;
    if (kGameInfo.isMarketed == true) 
    {
        loadType = 1;
    }
    gsPostToURL("http://appapi2.gamersky.com/game/GetAllReview",
        "POST",
        "{\"articleId\":\"" + kGameId + "\",\"pageIndex\":1,\"pageSize\":5,\"floorPageSize\":3,\"dataType\":1,\"loadType\":" + loadType + ",\"isFiltra\":\"2\"}",
        true,
        true,
        "GS.addUserGameCommentsElement");
}
GS.addUserGameCommentsElement = function (response) 
{
    var commentsArray
        = null;

    if (response != null
        && response != undefined
        && response.length > 0) 
    {
        var responseJson
            = JSON.parse(decodeURIComponent(response));

        if (responseJson.result != null
            && responseJson.result != undefined) 
        {
            if (responseJson.errorCode != null
                && responseJson.errorCode != undefined) 
            {
                if (Number(responseJson.errorCode) == 0) 
                {
                    commentsArray
                        = responseJson.result.reviews;
                }
            }
        }
        else
        {
            if (responseJson.reviews != null
                && responseJson.reviews != undefined) 
            {
                commentsArray = responseJson.reviews;
            }
        }
    }

    if (commentsArray == null
        || commentsArray == undefined) 
    {
        return;
    }

    var userCommentsNode
        = document.getElementById("userComments");
    userCommentsNode.className = "UserComments";
    userCommentsNode.innerText = "";
    var commentsCaption
        = document.createElement("div");
    commentsCaption.innerText = "玩家点评";
    commentsCaption.className = "Caption";
    if (gsIsCurrentOSAndroid() == true) 
    {
        commentsCaption.className = "Caption Android";
    }
    userCommentsNode.appendChild(commentsCaption);

    if (commentsArray.length == 0) 
    {
        //添加空内容样式元素

        var noDataImgNode
            = document.createElement("div");
        noDataImgNode.className = "NoDataImg";
        userCommentsNode.appendChild(noDataImgNode);

        var noDataTipNode
            = document.createElement("div")
        noDataTipNode.className = "NoDataTips";
        noDataTipNode.innerText = "暂无内容，去发表评论吧～";
        userCommentsNode.appendChild(noDataTipNode);

        return;
    }

    if (commentsArray != null
        && commentsArray != undefined
        && commentsArray.length > 0) 
    {
        var commentItems = new Array();
        for (var index = 0; index < commentsArray.length; index++) 
        {
            const element = commentsArray[index];
            var commentItem
                = GS.addAUserGameCommentElement(element);
            if (commentItem != null
                && commentItem != undefined) 
            {
                commentItems.push(commentItem);
            }
        }

        if (commentItems.length == 0) 
        {
            return;
        }

        var moreComments
            = document.createElement("div");
        moreComments.innerText = "更多";
        moreComments.className = "More";
        userCommentsNode.appendChild(moreComments);
        moreComments.onclick = function ()
        {
            var msg
                = "GSApp://open.gameComment.app?{\"gameId\":\"" + kGameId + "\",\"gameName\":\"" + kGameInfo.Title + "\",\"isMarketed\":\"" + kGameInfo.isMarketed + "\",\"steamId\":\"" + kGameInfo.SteamId + "\",\"operate\":\"allComments\"}";
            GS.sendMessage(msg);
        };

        for (var index = 0; index < commentItems.length; index++) 
        {
            const element = commentItems[index];
            userCommentsNode.appendChild(element);
        }

        ///最后一组元素添加更多的按钮
        var moreGameCommentNode
            = document.createElement("div");
        moreGameCommentNode.className = "MoreGameComment";
        moreGameCommentNode.innerText = "查看更多精彩点评";

        userCommentsNode.appendChild(moreGameCommentNode);

        moreGameCommentNode.onclick = function ()
        {
            var msg
                = "GSApp://open.gameComment.app?{\"gameId\":\"" + kGameId + "\",\"gameName\":\"" + kGameInfo.Title + "\",\"isMarketed\":\"" + kGameInfo.isMarketed + "\",\"steamId\":\"" + kGameInfo.SteamId + "\",\"operate\":\"allComments\"}";
            GS.sendMessage(msg);
        };


        //分割线

    }
    else
    {
        ///没数据
    }
}

GS.gameCommentWithExpandButton = function (gameComment)
{
    var gameCommentMaxLength = 324;
    return GSApp.UIControls.textToHtmlWithExpandButtonInMaxLength(
        gameComment,
        gameCommentMaxLength);
}

GS.addAUserGameCommentElement = function (commentElement)
{
    //likeType  0	没有选择想玩，或玩过。1  玩过。2  想玩。

    ///未上市游戏只显示想玩的游戏
    if (commentElement.likeType == 1) 
    {
        if (kGameInfo.isMarketed == false) 
        {
            return;
        }
    }

    var commentId = commentElement.reviewid;

    var isRealPlayer = false;

    if (typeof (commentElement.isUserRealPlayer) != "undefiend"
        && commentElement.isUserRealPlayer != null) 
    {
        isRealPlayer = commentElement.isUserRealPlayer;
    }

    var userGameCommentNode
        = document.createElement("div");
    userGameCommentNode.className = "UserGameComment";
    userGameCommentNode.setAttribute("commentId", commentElement.reviewid);
    userGameCommentNode.id = "comment_" + commentElement.reviewid;

    var userInfo
        = Object();
    userInfo.userId = commentElement.user_id;
    userInfo.userName = commentElement.nickname;
    userInfo.userHeadImageURL = commentElement.img_URL;
    userInfo.userLevel = commentElement.userLevel;
    userInfo.userScore = commentElement.rating;
    userInfo.userGroupId = commentElement.userGroupId;
    userInfo.userSubtitle = GS.captionOfTimeInList(commentElement.modify_time);
    userInfo.userPlayedPlatform = commentElement.platform;
    userInfo.userPlayState = commentElement.likeType;
    userInfo.isUserRealPlayer = isRealPlayer;

    var userInfoBar
        = GS.addUserInfoBar(userInfo);
    userGameCommentNode.appendChild(userInfoBar);
    userInfoBar.style.marginRight = "30px";
    userInfoBar.style.marginLeft = "16px";
    userInfoBar.style.float = "left";

    var reportNode
        = document.createElement("div");
    reportNode.className = "Report";
    userGameCommentNode.appendChild(reportNode);
    reportNode.setAttribute("onclick", "GS.commentOperate(\"" + kGameId + "\",\"" + commentId + "\",\"" + userInfo.userId + "\",\"" + userInfo.userName + "\",\"" + commentElement.content + "\")");

    var contentNode
        = document.createElement("div");
    contentNode.className = "Content";
    userGameCommentNode.appendChild(contentNode);

    contentNode.innerHTML = GS.gameCommentWithExpandButton(commentElement.content);

    contentNode.setAttribute("onclick", "GS.openUserGameCommentDetail(" + commentId + ",\"" + userInfo.userId + "\",\"" + userInfo.userName + "\")");

    var praiseNode
        = document.createElement("div");
    praiseNode.className = "Praise";
    userGameCommentNode.appendChild(praiseNode);
    praiseNode.innerText = commentElement.like;
    praiseNode.setAttribute("comment_Id", commentId);
    praiseNode.setAttribute("user_Id", commentElement.user_id);
    praiseNode.setAttribute("selected", false);
    praiseNode.setAttribute("onclick", "GS.praiseGameComment(" + kGameId + "," + commentId + ")");

    var commentNode
        = document.createElement("div");
    commentNode.className = "Comment";
    userGameCommentNode.appendChild(commentNode);
    commentNode.innerText = commentElement.reviewCount;
    commentNode.setAttribute("onclick", "GS.replyGameComment(\"" + kGameId + "\",\"" + commentId + "\",\"" + userInfo.userId + "\",\"" + userInfo.userName + "\")");

    var subscribeNode
        = document.createElement("div");
    subscribeNode.className = "Subscribe";
    userGameCommentNode.appendChild(subscribeNode);
    subscribeNode.innerText = GS.captionOfTimeInList(commentElement.modify_time);

    var splitNode
        = document.createElement("div");
    splitNode.className = "SplitLine";
    if (gsIsCurrentOSAndroid()) 
    {
        splitNode.className = "SplitLine Android";
    }
    userGameCommentNode.appendChild(splitNode);

    return userGameCommentNode;
}

///////////////////////////////
/// 9.精选评测
///////////////////////////////
GS.addGameEvaluations = function () 
{
    var gameEvaluations
        = document.createElement("div");
    gameEvaluations.id = "gameEvaluations";
    gameEvaluations.className = "Loading";
    GS.addElement(gameEvaluations);

    var subjectId = kGameInfo.TopicId;
    if (subjectId != null
        && subjectId != undefined
        && !isNaN(Number(subjectId))
        && subjectId.length > 0) 
    {
        // \"contentMinLength\":100,
        // \"contentMaxLength\":200,
        gsPostToURL("http://i.gamersky.com/appapi/v5/getClubTopicsList",
            "POST",
            "{\"clubIds\":[],\"clubTypes\":[\"puTong\"],\"topicType\":\"quanBu\",\"subjectIds\":[\"" + subjectId + "\"],\"userId\":\"\",\"orderType\":\"jingHua_DianZan_DESC\",\"contentMinLength\":100, \"contentMaxLength\":200,\"cacheMinutes\":10,\"pageIndex\": 1,\"pageSize\":20}",
            true,
            false,
            "GS.addGameEvaluationsElement");
    }
    else
    {
        gameEvaluations.className = "";
    }
}

GS.addGameEvaluationsElement = function (response) 
{
    var responseJson = null;
    var topics = null;
    try
    {
        responseJson
            = JSON.parse(decodeURIComponent(response));
        if (responseJson != null
            && responseJson != undefined) 
        {
            if (responseJson.errorCode == 0) 
            {
                if (responseJson.result != null
                    && responseJson.result != undefined) 
                {
                    var jsonResult
                        = responseJson.result;
                    if (jsonResult.topics != null
                        && jsonResult.topics != undefined) 
                    {
                        topics = jsonResult.topics;
                    }
                }
            }
        }

        var evaluationsNode
            = document.getElementById("gameEvaluations");

        if (topics != null
            && topics != undefined
            && topics.length > 0) 
        {
            if (topics.length > 3) 
            {
                topics
                    = topics.splice(0, 3);
            }
            /////
            evaluationsNode.className = "GameEvaluations";

            var evaluationCaption = document.createElement("div");
            evaluationCaption.className = "Caption";
            evaluationsNode.appendChild(evaluationCaption);

            var caption = document.createElement("div");
            caption.className = "Caption";
            if (gsIsCurrentOSAndroid() == true) 
            {
                caption.className = "Caption Android";
            }
            caption.innerText = "精选评测";
            evaluationCaption.appendChild(caption);

            var createEvaluation = document.createElement("div");
            createEvaluation.className = "CreateEvaluation";
            evaluationCaption.appendChild(createEvaluation);
            evaluationCaption.setAttribute("onclick", "GS.createANewGameEvaluation()");

            var createIcon = document.createElement("div");
            createIcon.className = "Icon";
            createEvaluation.appendChild(createIcon);

            var createCap = document.createElement("div");
            createCap.className = "Cap";
            createEvaluation.appendChild(createCap);
            createCap.innerText = "写评测";

            for (var index = 0; index < topics.length; index++) 
            {
                const evaluation = topics[index];

                var evaluationElement
                    = GS.addAGameEvaluationElement(evaluation);
                if (evaluationElement != null
                    && evaluationElement != undefined) 
                {
                    evaluationsNode.appendChild(evaluationElement);
                }
            }

            var more
                = document.createElement("div");
            more.className = "MoreGameEvaluations";
            evaluationsNode.appendChild(more);
            more.innerText = "查看更多游戏评测";
            more.setAttribute("onclick", "GS.openMoreGameEvaluations()");

        }
        else
        {
            evaluationsNode.className = "";
        }
    }
    catch (error)
    {
        console.log(error.toString());
    }
}

GS.createANewGameEvaluation = function () 
{
    var subjectId = kGameInfo.TopicId;
    var clubId = kGameInfo.ClubId;

    if (subjectId != null
        && subjectId != undefined
        && !isNaN(Number(subjectId))
        && subjectId.toString().length > 0)
    { }
    else
    {
        subjectId = "";
    }

    if (clubId != null
        && clubId != undefined
        && !isNaN(Number(clubId))
        && clubId.toString().length > 0)
    { }
    else
    {
        clubId = "";
    }

    var msg = "GSApp://create.topic.club.app?{\"clubId\":\"" + clubId + "\",\"subjectId\":\"" + subjectId + "\",\"callback\":\"GS.didTopicCreated\"}";
    GS.sendMessage(msg);
}

GS.didTopicCreated = function (responseString) 
{

}

GS.addAGameEvaluationElement = function (evaluationJson) 
{
    var gameEvaluationNode
        = document.createElement("div");
    gameEvaluationNode.className = "GameEvaluation";
    gameEvaluationNode.setAttribute("contentId", evaluationJson.topicId);
    gameEvaluationNode.id = "gameEvaluation_" + evaluationJson.topicId;
    gameEvaluationNode.setAttribute("isVideo", "false");

    var userInfo = Object();
    userInfo.userId = evaluationJson.userId.toString();
    userInfo.userName = evaluationJson.userName;
    userInfo.userHeadImageURL = evaluationJson.userHeadImageURL;
    userInfo.userLevel = evaluationJson.userLevel;
    userInfo.userScore = evaluationJson.gameScore;
    userInfo.userGroupId = evaluationJson.userGroupId;
    userInfo.userSubtitle = GS.captionOfTimeInList(evaluationJson.createTime);
    userInfo.userThirdPlatformBound = evaluationJson.thirdPlatformBound;

    var userInfoBar
        = GS.addUserInfoBar(userInfo);
    gameEvaluationNode.appendChild(userInfoBar);
    {

        try
        {
            var subs
                = userInfoBar.getElementsByClassName("PlayState");
            if (subs != null
                && subs != undefined
                && subs.length > 0) 
            {
                var sub = subs[0];
                sub.innerText = userInfo.userSubtitle;
            }
        } catch (error)
        {
            console.log(error.toString())
        };
    }

    //520版本暂时不加该部分功能.
    // var reportNode
    // = document.createElement("div");
    // reportNode.className = "Report";
    // gameEvaluationNode.appendChild(reportNode);
    // reportNode.setAttribute("onclick", "GS.commentOperate(\"" + kGameId + "\",\"" + evaluationJson.topicId + "\",\"" + userInfo.userId + "\",\"" + userInfo.userName + "\")");

    //评分大于0才显示
    if (evaluationJson.gameScore != null
        && evaluationJson.gameScore != undefined
        && evaluationJson.gameScore != 0
        && !isNaN(Number(evaluationJson.gameScore))) 
    {
        var gameScore
            = document.createElement("div");
        gameScore.className = "GameScores";
        gameEvaluationNode.appendChild(gameScore);

        var gameScoreStars
            = GS.addScoreStarsElement("InEvaluation", evaluationJson.gameScore);
        gameScore.appendChild(gameScoreStars);

        var gameScoreTip
            = document.createElement("div");
        gameScoreTip.className = "GameScoreTip";

        var scoreTip = "";
        if (evaluationJson.gameScore >= 0
            && evaluationJson.gameScore <= 2) 
        {
            scoreTip = "渣作";
        }
        else if (evaluationJson.gameScore > 2
            && evaluationJson.gameScore <= 4) 
        {
            scoreTip = "平庸";
        }
        else if (evaluationJson.gameScore > 4
            && evaluationJson.gameScore <= 6) 
        {
            scoreTip = "一般";
        }
        else if (evaluationJson.gameScore > 6
            && evaluationJson.gameScore <= 8) 
        {
            scoreTip = "佳作";
        }
        else if (evaluationJson.gameScore > 8
            && evaluationJson.gameScore <= 10) 
        {
            scoreTip = "神作";
        }
        gameScoreTip.innerText = scoreTip;
        gameScore.appendChild(gameScoreTip);
    }

    var isVideoTag = "false";
    if (evaluationJson.videoOriginURL != null
        && evaluationJson.videoOriginURL != undefined
        && evaluationJson.videoOriginURL.length > 0) 
    {
        isVideoTag = "true";
    }

    gameEvaluationNode.setAttribute("isVideo", isVideoTag);

    var jinghuaHTML
        = "";
    if (evaluationJson.uiStyles == "jingHua") 
    {
        jinghuaHTML
            = "<div class=\"TitleIcon\">精品</div>";
    }
    var titleNodeHTML
        = "<div class=\"Title\" onclick=\"GS.openUserGameEvaluation(\"" + evaluationJson.topicId + "\",\"" + evaluationJson.clubId + "\",\"" + isVideoTag + "\",\"" + evaluationJson.videoOriginURL + "\")\">"
        + jinghuaHTML
        + evaluationJson.topicTitle
        + "</div>";

    gameEvaluationNode.insertAdjacentHTML("beforeend", titleNodeHTML);

    var contentNode
        = document.createElement("div");
    contentNode.className = "Content";
    gameEvaluationNode.appendChild(contentNode);

    contentNode.innerHTML = GS.gameCommentWithExpandButton(evaluationJson.topicContent);

    contentNode.setAttribute("onclick", "GS.openUserGameEvaluation(\"" + evaluationJson.topicId + "\",\"" + evaluationJson.clubId + "\",\"" + isVideoTag + "\",\"" + evaluationJson.videoOriginURL + "\")");

    if (isVideoTag == "false") 
    {
        var imageJsons = evaluationJson.imageInfes;
        if (imageJsons != null
            && imageJsons != undefined
            && imageJsons.length > 0) 
        {
            var imagesNode
                = document.createElement("div");
            imagesNode.className = "Images";
            gameEvaluationNode.appendChild(imagesNode);

            if (imageJsons.length > 3) 
            {
                imageJsons
                    = imageJsons.splice(0, 3);
            }

            var imageHTML = "";
            for (var index = 0; index < imageJsons.length; index++) 
            {
                const imageJson = imageJsons[index];

                ///添加一个图片
                var gifNodeHTML = "";
                if (imageJson.isGIF == "true") 
                {
                    gifNodeHTML
                        = "<div class=\"Gif\"></div>";
                }
                var imageClass = "Image";
                if (imageJson.length == 3) 
                {
                    imageClass = "Image ThreeImageStyle";
                }
                var imageLen = ((window.innerWidth - 32 - 10) / 3.0) + "px";

                imageHTML
                    = imageHTML
                    + "<div class=\"" + imageClass + "\" id=\"" + imageJson.url + "\" style=\"width:" + imageLen + ";height:" + imageLen + ";\" imageIndex=\"" + index + "\" >"
                    + gifNodeHTML
                    + "</div>";

                var msg
                    = "GSApp://download.image.app?{\"url\":\"" + imageJson.url + "\",\"callback\":\"GS.showGameEvaluationImage\"}";
                GS.sendMessage(msg);
            }
            imagesNode.innerHTML = imageHTML;

            imagesNode.style.height = ((window.innerWidth - 32 - 10) / 3.0) + "px";
        }
    }

    var videoURL = evaluationJson.videoOriginURL;
    if (videoURL != null
        && videoURL != undefined
        && videoURL.length > 0) 
    {
        ///视频类型
        var videoThumbnailURL = evaluationJson.videoThumbnailURL;
        // var videoThumbnailURL = "https://img1.gamersky.com/upimg/pic/2019/09/20/201909201135481450_small.jpg";   测试用
        if (videoThumbnailURL != null
            && videoThumbnailURL != undefined
            && videoThumbnailURL.length > 0) 
        {
            var videoNode = document.createElement("div");
            videoNode.className = "Video";
            videoNode.style.width = (window.innerWidth - 32) + "px";
            videoNode.style.height = (window.innerWidth - 32) / 16 * 9 + "px";
            videoNode.style.background = "url(" + videoThumbnailURL + ")";
            videoNode.style.backgroundRepeat = "no-repeat";
            videoNode.style.backgroundSize = "cover";
            var playTip = document.createElement("div");
            playTip.className = "Play";
            videoNode.appendChild(playTip);
            gameEvaluationNode.appendChild(videoNode);
            videoNode.setAttribute("onclick", "GS.openUserGameEvaluation(\"" + evaluationJson.topicId + "\",\"" + evaluationJson.clubId + "\",\"" + isVideoTag + "\",\"" + evaluationJson.videoOriginURL + "\")");
        }
    }

    var praiseNode
        = document.createElement("div");
    praiseNode.className = "Praise";
    gameEvaluationNode.appendChild(praiseNode);
    praiseNode.innerText = evaluationJson.praisesCount;
    praiseNode.setAttribute("evaluation_Id", evaluationJson.topicId);
    praiseNode.setAttribute("user_Id", evaluationJson.userId);
    praiseNode.setAttribute("selected", false);
    praiseNode.setAttribute("onclick", "GS.praiseUserGameEvaluation(" + evaluationJson.topicId + ")");

    var commentNode
        = document.createElement("div");
    commentNode.className = "Comment";
    gameEvaluationNode.appendChild(commentNode);
    commentNode.innerText = evaluationJson.commentsCount;
    commentNode.setAttribute("onclick", "GS.commentAGameEvaluation(\"" + evaluationJson.topicId + "\")");

    var splitNode
        = document.createElement("div");
    splitNode.className = "SplitLine";
    gameEvaluationNode.appendChild(splitNode);

    return gameEvaluationNode;
}

GS.openUserGameEvaluation = function (topicId, clubId, isVideo, videoURL) 
{
    var videoTag = "";
    if (isVideo == "true")
    {
        videoTag = "&gsAppVideoURL=true";
    }
    var videoType = "";
    if (videoURL != null
        && videoURL != undefined
        && videoURL.length > 0) 
    {
        if (videoURL.indexOf("bilibili") != -1) 
        {
            videoType = "&gsAppVideoSource=bilibili";
        }
    }
    var msg = "http://club.gamersky.com/activity/" + topicId + "?club=" + clubId + videoTag + videoType;
    GS.sendMessage(msg);
}

GS.praiseUserGameEvaluation = function (topicId) 
{
    var evaluationNode = document.getElementById("gameEvaluation_" + topicId);
    if (evaluationNode != null
        && evaluationNode != undefined) 
    {
        if (evaluationNode.childNodes != null
            && evaluationNode.childNodes != undefined) 
        {
            for (var index = 0; index < evaluationNode.childNodes.length; index++) 
            {
                const childNode = evaluationNode.childNodes[index];

                if (childNode.className == "Praise"
                    && childNode.getAttribute("evaluation_id") == topicId) 
                {
                    var praiseNode = childNode;

                    var praiseCount = praiseNode.innerText;
                    praiseCount += 1;
                    praiseNode.innerText = praiseCount;
                    praiseNode.className = "Praised";
                    var msg = "GSApp://praise.praiseInfo.content.app?{\"contentType\":\"zhuTi.quanZi\",\"contentId\":\"" + topicId + "\",\"callback\":\"GS.didGameEvaluationPraised\"}";
                    GS.sendMessage(msg);
                    break;
                }
            }
        }
    }
}

GS.didGameEvaluationPraised = function ()
{ }

GS.commentAGameEvaluation = function (topicId)
{
    var msg = "GSApp://create.comment.club.app?{\"topicId\":\"" + topicId + "\",\"clubId\":\"" + kGameInfo.ClubId + "\",\"callback\":\"GS.didCommentCreated\"}";
    GS.sendMessage(msg);
}

GS.didCommentCreated = function (responseString) 
{

}

GS.didCreateGameEvaluationComment = function (response)
{ }

GS.openMoreGameEvaluations = function () 
{
    var msg = "GSApp://open.app?{\"contentType\":\"huaTi.quanZi\",\"content\":\"" + kGameInfo.TopicId + "\"}";

    GS.sendMessage(msg);
}

GS.showGameEvaluationImage = function (imageUrl, imageStaticUrl) 
{
    if (imageUrl != null
        && imageUrl != undefined
        && imageUrl.length > 0) 
    {
        var imageNode = document.getElementById(imageUrl);
        if (imageNode != null
            && imageNode != undefined) 
        {
            if (imageStaticUrl != null
                && imageStaticUrl != undefined
                && imageStaticUrl.length > 0) 
            {
                imageNode.setAttribute("staticURL", imageStaticUrl);
                imageNode.style.background = "url(\"" + imageStaticUrl + "\")";
                imageNode.style.backgroundSize = "cover";

                imageNode.onclick = function ()
                {
                    GS.browseImageWithImage(this.getAttribute("id"), parseInt(this.getAttribute("imageIndex")));
                }
            }
        }
    }
}

var kEvaluationImages = null;
var kEvaluationImageNodes = null;
GS.browseImageWithImage = function (imageUrl, defaultIndex)
{
    kEvaluationImages = new Array();
    kEvaluationImageNodes = new Array();

    if (imageUrl != null
        && imageUrl != undefined
        && imageUrl.length > 0) 
    {
        var imageNode = document.getElementById(imageUrl);
        if (imageNode != null
            && imageNode != undefined) 
        {
            var images
                = imageNode.parentNode;
            if (images
                && images.children) 
            {
                for (var index = 0; index < images.children.length; index++) 
                {
                    const image = images.children[index];
                    kEvaluationImageNodes.push(image);
                    if (image) 
                    {
                        var imagesource = new Object();

                        imagesource.imageTinyURL = image.getAttribute("id");

                        var imgURL = image.getAttribute("id");
                        var originURL = "";
                        var hdURL = null;

                        if (imgURL.indexOf("tiny_") != -1) 
                        {
                            originURL
                                = imgURL.replace("tiny_", "small_");
                            hdURL
                                = imgURL.replace("tiny_", "origin_");
                        }

                        imagesource.imageURL = originURL;
                        imagesource.imageHDURL = hdURL;

                        kEvaluationImages.push(imagesource);
                    }
                }

                if (gsIsCurrentOSIOS())
                {
                    var msg
                        = "GSApp://open.image.app?{\"imageCounts\":\"" + kEvaluationImages.length + "\""
                        + ", \"defaultIndex\":\"" + defaultIndex + "\""
                        + ", \"callback\":\"GS.getEvaluationImageInfoWithIndex\"}";
                    GS.sendMessage(msg);
                }
                else if (gsIsCurrentOSAndroid())
                {
                    /*
                    images数组元素定义:
                    {
                        imageURL:xxx,
                        imageTinyURL:xxx,
                        imageHDURL:xxx,
                    }
                    */
                    var imagesText = "[";
                    for (var i = 0; i < kEvaluationImages.length; i++) 
                    {
                        const media = kEvaluationImages[i];
                        imagesText += "{\"imageURL\":\"" + media.imageURL + "\",\"imageTinyURL\":\"" + media.imageTinyURL + "\",\"imageHDURL\":\"" + media.imageHDURL + "\"}";
                        if (i != kEvaluationImages.length - 1) 
                        {
                            imagesText += ",";
                        }
                    }
                    imagesText += "]";

                    var msg
                        = "GSApp://open.image.app?{\"images\":" + imagesText + ",\"defaultIndex\":\"" + defaultIndex + "\"}";
                    GS.sendMessage(msg);

                }
            }
        }
    }
}

GS.getEvaluationImageInfoWithIndex = function (index) 
{
    /*
	回调消息体
	{index:index,imageURL:xxx,imageTinyURL:xxx,imageHDURL:xxx};
	*/
    if (kEvaluationImages != null
        && kEvaluationImages != undefined
        && kEvaluationImages.length > 0) 
    {
        if (index >= 0
            && index < kEvaluationImages.length) 
        {
            var image
                = kEvaluationImages[index];
            var imageNode
                = kEvaluationImageNodes[index];

            var imageSourceFrame =
                "[0, 0, " + window.innerWidth + ", " + parseInt(window.innerWidth * 9 / 16) + "]";

            if (imageNode != null
                && imageNode != undefined
                && imageNode.getAttribute("id") == image.imageTinyURL) 
            {
                imageSourceFrame
                    = "[" + imageNode.offsetLeft + "," + imageNode.offsetTop + "," + imageNode.offsetWidth + "," + imageNode.offsetHeight + "]";
            }

            var msg
                = "{\"index\":\"" + index + "\""
                + ", \"imageURL\":\"" + image.imageURL + "\""
                + ", \"imageTinyURL\":\"" + image.imageTinyURL + "\""
                + ", \"imageHDURL\":\"" + image.imageHDURL + "\""
                + ", \"frame\":" + imageSourceFrame + "}";

            return msg;
        }
    }
}


///////////////////////////////
/// 10.相关推荐
///////////////////////////////
var kCorrelationNews = new Array();
GS.addCorrelation = function () 
{
    var correlationNews
        = document.createElement("div");
    correlationNews.id = "correlation";
    // correlationNews.innerText = "加载中...";
    correlationNews.className = "Loading";
    GS.addElement(correlationNews);
    //向外发消息
    gsPostToURL("http://appapi2.gamersky.com/v2/TwoCorrelation",
        "POST",
        "{\"contentId\":\"" + kGameId + "\",\"gameId\":\"" + kGameId + "\",\"contentType\":\"news\",\"correlationFilter\":\"zhongPingTuiJian\",\"pageIndex\":\"1\",\"elementsCountPerPage\":\"10\"}",
        true,
        true,
        "GS.checkTheCorrelations");
};
//验证数据
GS.checkTheCorrelations = function (response)
{
    var newsCorrelations
        = null;

    if (response != null
        && response != undefined
        && response.length > 0) 
    {
        var responseJson
            = JSON.parse(decodeURIComponent(response));

        if (responseJson != null
            && responseJson != undefined) 
        {
            if (responseJson.result != null
                && responseJson.result != undefined) 
            {
                if (responseJson.errorCode != null
                    && responseJson.errorCode != undefined) 
                {
                    if (Number(responseJson.errorCode) == 0) 
                    {
                        newsCorrelations
                            = responseJson.result;
                    }
                }
            }
            else
            {
                if (responseJson != null
                    && responseJson != undefined) 
                {
                    newsCorrelations = responseJson;
                }
            }
        }

    }
    if (newsCorrelations != null
        && newsCorrelations != undefined) 
    {
        var correlationElements = null;

        if (newsCorrelations.result != null
            && newsCorrelations.result != undefined) 
        {
            correlationElements = newsCorrelations.result;
        }
        else
        {
            correlationElements = newsCorrelations;
        }


        if (correlationElements != null
            && correlationElements != undefined) 
        {
            kCorrelationNews = correlationElements;

            if (correlationElements.length > 3) 
            {
                correlationElements
                    = correlationElements.slice(0, 3);
                GS.addCorrelationElement(correlationElements);
            }
            else
            {
                ///再请求推荐新闻数据
                gsPostToURL("http://appapi2.gamersky.com/v2/TwoCorrelation",
                    "POST",
                    "{\"contentId\":\"" + kGameId + "\",\"gameId\":\"" + kGameId + "\",\"contentType\":\"news\",\"correlationFilter\":\"\",\"pageIndex\":\"1\",\"elementsCountPerPage\":\"10\"}",
                    true,
                    true,
                    "GS.didGetRecommandNews");
            }
        }
    }
}
GS.didGetRecommandNews = function (response) 
{
    var newsCorrelations
        = null;

    if (response != null
        && response != undefined
        && response.length > 0) 
    {
        var responseJson
            = JSON.parse(decodeURIComponent(response));

        if (responseJson != null
            && responseJson != undefined) 
        {
            if (responseJson.errorCode != null
                && responseJson.errorCode != undefined) 
            {
                if (Number(responseJson.errorCode) == 0) 
                {
                    if (responseJson.result != null
                        && responseJson.result != undefined) 
                    {
                        if (responseJson.result.result != null
                            && responseJson.result.result != undefined
                            && responseJson.result.result.length > 0) 
                        {
                            newsCorrelations
                                = responseJson.result.result;
                        }
                        else
                        {
                            newsCorrelations
                                = responseJson.result;
                        }
                    }
                }
            }
            else
            {
                try
                {
                    newsCorrelations
                        = responseJson
                }
                catch (error)
                {
                    console.log(error.toString());
                }
            }
        }
        else
        {
            if (responseJson != null
                && responseJson != undefined) 
            {
                newsCorrelations = responseJson.result;
            }
        }
    }

    if (newsCorrelations != null
        && newsCorrelations != undefined
        && newsCorrelations.length > 0) 
    {
        var correlationElements
            = newsCorrelations;

        if (kCorrelationNews == null
            || kCorrelationNews == undefined) 
        {
            kCorrelationNews = Array();
        }

        if (correlationElements != null
            && correlationElements != undefined
            && correlationElements.length > 0)
        {
            kCorrelationNews
                = kCorrelationNews.concat(correlationElements);
        }

        if (kCorrelationNews != null
            && kCorrelationNews != undefined) 
        {
            if (kCorrelationNews.length > 3) 
            {
                kCorrelationNews
                    = kCorrelationNews.slice(0, 3);
            }

            GS.addCorrelationElement(kCorrelationNews);
        }
    }
}
GS.addACorrelateionNews = function (newsElement) 
{
    var correlationNewsNode
        = document.createElement("div");
    correlationNewsNode.className = "CorrelationNews";

    var titleNode
        = document.createElement("div");
    titleNode.className = "Title";
    correlationNewsNode.appendChild(titleNode);
    titleNode.innerText = newsElement.title;

    var thumbnailNode
        = document.createElement("div");
    thumbnailNode.className = "Thumbnail";
    correlationNewsNode.appendChild(thumbnailNode);

    var thumbURL = "";
    if (newsElement.thumbnailUrl != null
        && newsElement.thumbnailUrl != undefined
        && newsElement.thumbnailUrl.length > 0) 
    {
        thumbURL
            = newsElement.thumbnailUrl;
    }
    else
    {
        if (newsElement.thumbnailURLs != null
            && newsElement.thumbnailURLs != undefined
            && newsElement.thumbnailURLs.length > 0) 
        {
            thumbURL
                = newsElement.thumbnailURLs[0];
        }
    }
    if (thumbURL != null
        && thumbURL != undefined
        && thumbURL.length > 0) 
    {
        thumbnailNode.style.background = "url(" + newsElement.thumbnailUrl + ")";
    }
    else
    {
        thumbnailNode.style.background = "#aaaaaa";
    }
    thumbnailNode.style.backgroundSize = "cover";

    var timeNode
        = document.createElement("div");
    timeNode.className = "Time";
    correlationNewsNode.appendChild(timeNode);
    timeNode.innerText = GS.captionOfTimeInList(newsElement.dateTime);

    var commentNode
        = document.createElement("div");
    commentNode.className = "Comment";
    correlationNewsNode.appendChild(commentNode);
    commentNode.innerText = newsElement.commentsCount + "评论";

    var splitLine
        = document.createElement("div");
    splitLine.className = "SplitLine";
    correlationNewsNode.appendChild(splitLine);

    correlationNewsNode.onclick = function ()
    {
        GS.sendMessage("GSApp://open.news.app?{\"contentId\":\"" + newsElement.contentId + "\",\"contentType\":\"" + newsElement.contentType + "\",\"operate\":\"open\"}");
    };
    correlationNewsNode.ontouchstart = function ()
    {
        correlationNewsNode.style.background = "#eeeeee";
    }
    correlationNewsNode.ontouchend = function ()
    {
        correlationNewsNode.style.background = "";
    }
    correlationNewsNode.ontouchmove = function ()
    {
        correlationNewsNode.style.background = "";
    }
    correlationNewsNode.ontouchcancel = function ()
    {
        correlationNewsNode.style.background = "";
    }

    return correlationNewsNode;
}
GS.addCorrelationElement = function (correlationNews) 
{
    var correlationNode
        = document.getElementById("correlation");
    correlationNode.className = "Correlation";
    var correlationTitle
        = document.createElement("div");
    correlationTitle.innerText = "相关推荐";
    correlationTitle.className = "Caption";
    if (gsIsCurrentOSAndroid() == true) 
    {
        correlationTitle.className = "Caption Android";
    }
    correlationNode.appendChild(correlationTitle);

    var correlationMore
        = document.createElement("div");
    correlationMore.className = "More";
    correlationNode.appendChild(correlationMore);
    correlationMore.innerText = "更多";
    correlationMore.onclick = function () 
    {
        var msg
            = "GSApp://open.news.app?{\"contentId\":\"" + kGameId + "\",\"operate\":\"more\"}";
        GS.sendMessage(msg);
    }

    for (var index = 0; index < correlationNews.length; index++) 
    {
        const newsElement = correlationNews[index];
        var newsNode
            = GS.addACorrelateionNews(newsElement);
        correlationNode.appendChild(newsNode);
        if (index == correlationNews.length - 1) 
        {
            var line = null;
            for (var index = 0; index < newsNode.childNodes.length; index++) 
            {
                const element = newsNode.childNodes[index];
                if (element.className == "SplitLine") 
                {
                    line = element;
                }
            }
            if (line != null
                || line != undefined) 
            {
                newsNode.removeChild(line);
            }
        }
    }
}


//操作事件
GS.praiseGameComment = function (gameId, commentId) 
{
    var praiseNodes
        = document.getElementsByClassName("Praise");
    var praiseNode = null;
    for (var index = 0; index < praiseNodes.length; index++) 
    {
        const element = praiseNodes[index];
        if (element.getAttribute("comment_Id") == commentId) 
        {
            praiseNode = element;
            break;
        }
    }

    if (praiseNode != null
        && praiseNode != undefined
        && praiseNode.getAttribute("selected") != true) 
    {
        var author
            = praiseNode.getAttribute("user_Id");
        var msg
            = "GSApp://praise.gameComment.app?{\"gameId\":\""
            + gameId
            + "\",\"commentId\":\""
            + commentId +
            "\",\"commentUserId\":\""
            + author
            + "\",\"callback\":\"GS.didGameCommentPrised\"}";
        GS.sendMessage(msg);
    }
}

GS.didGameCommentPrised = function (commentId)
{
    var praiseNodes
        = document.getElementsByClassName("Praise");
    var praiseNode = null;
    for (var index = 0; index < praiseNodes.length; index++) 
    {
        const element = praiseNodes[index];
        if (element.getAttribute("comment_Id") == commentId) 
        {
            praiseNode = element;
            break;
        }
    }

    if (praiseNode != null
        && praiseNode != undefined
        && praiseNode.getAttribute("selected") != true) 
    {
        praiseNode.className = "Praised";
        var praiseCount
            = praiseNode.innerText;
        praiseNode.innerText
            = Number(praiseCount) + 1;
    }
}

GS.replyGameComment = function (gameId, commentId, commentUserId, commentUserName)
{
    var msg
        = "GSApp://reply.gameComment.app?{\"gameId\":\""
        + gameId
        + "\",\"commentId\":\""
        + commentId
        + "\",\"commentUserId\":\""
        + commentUserId
        + "\",\"commentUserName\":\""
        + commentUserName
        + "\",\"callback\":\"GS.didGameCommentReply\"}";
    GS.sendMessage(msg);
}
GS.commentOperate = function (gameId, commentId, commentUserId, commentUserName, commentContent) 
{
    var msg
        = "GSApp://operate.gameComment.app?{\"gameId\":\""
        + gameId
        + "\",\"commentId\":\""
        + commentId
        + "\",\"commentUserId\":\""
        + commentUserId
        + "\",\"commentUserName\":\""
        + commentUserName
        + "\",\"commentContent\":\""
        + commentContent
        + "\",\"callback\":\"GS.didGameCommentReply\"}";
    GS.sendMessage(msg);
}
GS.openUserGameCommentDetail = function (commentId, commentUserId, commentUserName)
{
    var msg
        = "GSApp://open.gameComment.app?{"
        + "\"commentId\":\"" + commentId
        + "\", \"gameId\":\"" + kGameId
        + "\", \"gameName\":\"" + kGameInfo.Title
        + "\", \"commentUserId\":\"" + commentUserId
        + "\", \"commentUserName\":\"" + commentUserName
        + "\", \"isMarketed\":\"" + kGameInfo.isMarketed
        + "\", \"operate\":\"commentDetail\"}";

    GS.sendMessage(msg);
}
GS.didGameUserCommentShowAllContent = function (commentId) 
{
    var userCommentNode
        = document.getElementById("comment_" + commentId);
    for (var index = 0; index < userCommentNode.childNodes.length; index++) 
    {
        const element = userCommentNode.childNodes[index];
        if (element.className == "Content") 
        {
            element.className = "Content Unfold";
        }
        if (element.className.indexOf("ShowAll") != -1) 
        {
            element.style.display = "none";
        }
    }
}

///基础数据/操作
GS.getGameInfo = function (callBack) 
{
    gsPostToURL("http://appapi2.gamersky.com/v4/getGame",
        "POST",
        "{\"gameId\":\""
        + kGameId +
        "\",\"gameModeFieldNames\":\"DeputyNodeId,Position,Title,EnTitle,Intro,GameMake,GameAuthor,AllTime,AllTimeT,PCTimeT,XboxOneTimeT,PS4TimeT,NintendoSwitchTimeT,PS5TimeT,XboxSeriesXTimeT,PCTime,XboxOneTime,PS4Time,NintendoSwitchTime,PS5Time,XboxSeriesXTime,OfficialChinese,Ps4Chinese,XboxChinese,NsChinese,GameType,Peizhi,GoodText,SteamId,TopicId,ClubId,GameTime\",\"gameRelatedFieldNames\":\"gsScore,playCount,expectCount,gameTag\",\"gameTagsCount\":20}",
        true,
        true,
        callBack);
}

GS.transferGameInfoIntoContent = function (response) 
{
    var gameInfo = null;

    if (response != null
        && response != undefined
        && response.length > 0) 
    {

        var gameInfoJson
            = JSON.parse(decodeURIComponent(response));

        if (gameInfoJson.result != null
            && gameInfoJson.result != undefined) 
        {
            if (gameInfoJson.errorCode != null
                && gameInfoJson.errorCode != undefined) 
            {
                if (Number(gameInfoJson.errorCode) == 0) 
                {
                    gameInfo
                        = gameInfoJson.result;
                }
            }
        }
        else
        {
            if (gameInfoJson != null
                && gameInfoJson != undefined) 
            {
                gameInfo = gameInfoJson;
            }
        }

        if (gameInfo)
        {
            //区分平台
            {
                var platForms
                    = Array();
                if (gameInfo.PCTime != null
                    && gameInfo.PCTime != undefined
                    && gameInfo.PCTime.length > 0) 
                {
                    platForms.push("PC");
                }
                if (gameInfo.PS4Time != null
                    && gameInfo.PS4Time != undefined
                    && gameInfo.PS4Time.length > 0) 
                {
                    platForms.push("PS");
                }
                if (gameInfo.NintendoSwitchTime != null
                    && gameInfo.NintendoSwitchTime != undefined
                    && gameInfo.NintendoSwitchTime.length > 0) 
                {
                    platForms.push("Switch");
                }
                if (gameInfo.XboxOneTime != null
                    && gameInfo.XboxOneTime != undefined
                    && gameInfo.XboxOneTime.length > 0) 
                {
                    platForms.push("Xbox");
                }
                gameInfo.platForms
                    = platForms;
            }

            //加工游戏标签数据
            {
                var gameType = GS.switchGameTypeWithGameNodeId(gameInfo.DeputyNodeId);
                var gameTag = gameInfo.gameTag;

                var typeArray
                    = gameType.length > 0 ? gameType.split(",") : Array();

                //容错空元素+自身去重+插入游戏类型
                var tags
                    = Array();
                for (var index = 0; index < gameTag.length; index++) 
                {
                    const element = gameTag[index];
                    tags.push(element);
                }
                var typeCopy
                    = Array();
                for (var index = 0; index < typeArray.length; index++) 
                {
                    const element = typeArray[index];
                    if (element != null
                        && element != undefined
                        && element.length > 0) 
                    {
                        typeCopy.push(element)
                    }
                }
                ///!!!!!!
                typeArray = typeCopy;
                ///!!!!!!

                //去重

                for (var tagIndex = 0; tagIndex < gameTag.length; tagIndex++) 
                {
                    const gTag = gameTag[tagIndex];

                    for (var typeIndex = 0; typeIndex < typeArray.length; typeIndex++) 
                    {
                        const gType = typeArray[typeIndex];

                        if (gTag == gType) 
                        {
                            var repeatIndex = tags.indexOf(gTag);
                            if (repeatIndex != -1) 
                            {
                                tags.splice(repeatIndex, 1);
                            }
                        }
                    }
                }

                //再重新插入数据
                for (var index = 0; index < typeArray.length; index++) 
                {
                    const gType = typeArray[index];
                    var typeIndex
                        = typeArray.indexOf(gType);
                    if (typeIndex == -1) 
                    {
                        typeIndex == 0;
                    }
                    tags.splice(typeIndex, 0, gType);
                }
                gameTag
                    = tags;

                //标签的特殊处理
                if (GS.gameIsOnlineWithGameTags(gameTag) == true) 
                {
                    var onlineTagIndex
                        = GS.gameOnlineTagsIndex(gameTag);
                    if (onlineTagIndex >= 5) 
                    {
                        ///查看次序: 如果gametag对应的联机字段index是大于5的,就放到第5位,小于不处理.
                        //交换次序:::	
                        gameTag.splice(4, 1, gameTag.splice(onlineTagIndex, 1, gameTag[4]));
                    }
                }

                gameInfo.gameTag
                    = gameTag;
            }

            //是否上市了
            var isMarketed = false;
            var marketDate = Date.parse(gameInfo.AllTimeT);
            if (isNaN(marketDate) != true) 
            {
                var nowDate = new Date();
                if (nowDate >= marketDate) 
                {
                    isMarketed = true;
                }
            }

            gameInfo.isMarketed = isMarketed;
        }
    }
    else
    {
    }
    return gameInfo;
}

//////////////////////////////////
/// 模板公用方法
//////////////////////////////////
GS.addElement = function (element)
{
    if (element != null
        && element != undefined) 
    {
        document.body.appendChild(element);
    }
}

//向外发消息
GS.sendMessage = function (msg) 
{
    if (!msg
        || msg.length < 1)
    {
        return;
    }

    msg
        = msg.replaceAll("\r\n", "");

    try
    {
        var aTag = document.createElement("A");
        aTag.href = msg;
        aTag.click();
    }
    catch (error)
    {
        if (gsIsCurrentOSAndroid())
        {
            location.href = msg;
        }
    }
}

//请求数据方法
function gsPostToURL(url, type, postData, useAPIHeader, needCache, callbackFuncationName)
{
    if (url == null
        || url.length < 1)
    {
        return;
    }

    if (postData == null)
    {
        postData = "";
    }
    else if (postData.length > 0)
    {
        postData = postData.replaceAll("\"", "\\\"");
    }

    if (useAPIHeader == null
        || typeof (useAPIHeader) == "undefined"
        || !useAPIHeader)
    {
        useAPIHeader = "false";
    }
    else
    {
        useAPIHeader = "true";
    }

    if (callbackFuncationName == null
        || typeof (callbackFuncationName) == "undefined")
    {
        callbackFuncationName = "";
    }

    var msg
        = "GSApp://post.app?{"
        + "\"url\":\"" + url + "\", "
        + "\"type\":\"" + type + "\","
        + "\"data\":\"" + postData + "\", "
        + "\"useAPIHeader\":" + useAPIHeader + ", "
        + "\"needCache\":" + needCache + ", "
        + "\"callback\":\"" + callbackFuncationName + "\"}";
    GS.sendMessage(msg);
}
// 列表场景（如新闻节点页，相关推荐区块等）
// 时间段			规则                                  示例
// 当日(0点后)		显示24小时制时间		17: 38
// 当日前（0点前）	显示昨日 + 24小时制时间	昨日09: 12
// 大于一天前		显示日期				10月14日
// 注意：
// 月日的数字，不需要补零，如：9月1日
// 时间的数字，需要补零，如：08: 01
GS.captionOfTimeInList = function (timeInterval)
{
    if (!timeInterval
        || isNaN(timeInterval))
    {
        return "";
    }

    timeInterval
        = Number(timeInterval);

    if (timeInterval < 1000000000000)
    {
        timeInterval *= 1000;
    }

    var kSecond = 1000;
    var kMinute = 1000 * 60;
    var kHour = kMinute * 60;
    var kDay = kHour * 24;

    var now
        = new Date();
    var timeIntervalOfNow
        = now.getTime();
    var time
        = new Date(timeInterval);
    var timeIntervalOfTodayZero
        = timeIntervalOfNow
        - now.getMilliseconds()
        - kSecond * now.getSeconds()
        - kMinute * now.getMinutes()
        - kHour * now.getHours();
    var timeIntervalOfYesterday
        = timeIntervalOfTodayZero
        - kDay;
    // 当日(0点后)		显示24小时制时间		17: 38
    if (timeInterval >= timeIntervalOfTodayZero)
    {
        var hourCaption
            = time.getHours().toString().complementZeroToIntNumberDigits(2);
        var minuteCaption
            = time.getMinutes().toString().complementZeroToIntNumberDigits(2);

        return hourCaption + ":" + minuteCaption;
    }
    // 当日前（0点前）	显示昨日 + 24小时制时间	昨日09: 12
    else if (timeInterval >= timeIntervalOfTodayZero)
    {
        var hourCaption
            = time.getHours().toString().complementZeroToIntNumberDigits(2);
        var minuteCaption
            = time.getMinutes().toString().complementZeroToIntNumberDigits(2);

        return "昨日" + hourCaption + ":" + minuteCaption;
    }
    // 大于一天前		显示日期				10月14日
    else
    {
        var monthCaption
            = (time.getMonth() + 1).toString();//.complementZeroToIntNumberDigits(2);
        var dayCaption
            = time.getDate().toString();//.complementZeroToIntNumberDigits(2);

        return monthCaption + "月" + dayCaption + "日";
    }
};

// 列表场景（如新闻节点页，相关推荐区块等）
// 时间段      规则                      示例
// 全部时间    显示发布时间的年月日时分。  2018-08-19 19:34
GS.captionOfTimeInContent = function (timeInterval)
{
    if (!timeInterval
        || isNaN(timeInterval))
    {
        return "";
    }

    if (timeInterval < 1000000000000)
    {
        timeInterval *= 1000;
    }

    var time = new Date(timeInterval);
    return time.getFullYear()
        + "-" + (time.getMonth() + 1)
        + "-" + time.getDate()
        + " "
        + time.getHours().toString().complementZeroToIntNumberDigits(2)
        + ":"
        + time.getMinutes().toString().complementZeroToIntNumberDigits(2);
};

//转换显示时间
GS.changeMarketTimeToShowing = function (marketTime) 
{
    var marketDate
        = Date.parse(marketTime);
    if (isNaN(marketDate)) 
    {
        return marketTime;
    }
    var date
        = new Date(marketDate);

    var marketTimeText
        = date.getFullYear().toString()
        + "-"
        + (date.getMonth() + 1).toString().complementZeroToIntNumberDigits(2)
        + "-"
        + date.getDate().toString().complementZeroToIntNumberDigits(2);

    return marketTimeText;
}

//根据父节点id转换成游戏标签
GS.switchGameTypeWithGameNodeId = function (gameTypeNum) 
{
    if (gameTypeNum == null
        || gameTypeNum == undefined
        || gameTypeNum.length == 0) 
    {
        return "";
    }
    var gameTypeList
        = [
            { "name": "第一人称射击", "searchid": "20066" },
            { "name": "第三人称射击游戏", "searchid": "20064" },
            { "name": "动作游戏", "searchid": "20042" },
            { "name": "角色扮演", "searchid": "20050" },
            { "name": "动作角色扮演", "searchid": "20052" },
            { "name": "竞速游戏", "searchid": "20043" },
            { "name": "即时战略", "searchid": "20047" },
            { "name": "策略游戏", "searchid": "20046" },
            { "name": "冒险游戏", "searchid": "20053" },
            { "name": "体育游戏", "searchid": "20045" },
            { "name": "模拟游戏", "searchid": "20062" },
            { "name": "格斗游戏", "searchid": "20061" },
            { "name": "飞行射击", "searchid": "20063" },
            { "name": "益智游戏", "searchid": "20048" },
            { "name": "音乐游戏", "searchid": "20065" },
            { "name": "恋爱养成", "searchid": "20049" }
        ];

    var gameTypes
        = gameTypeNum.split(",");

    var gameType = "";
    for (var typeDicIndex = 0; typeDicIndex < gameTypeList.length; typeDicIndex++) 
    {
        const typeDic = gameTypeList[typeDicIndex];

        for (var gTypeIndex = 0; gTypeIndex < gameTypes.length; gTypeIndex++) 
        {
            const gType = gameTypes[gTypeIndex];
            if (gType == typeDic.searchid) 
            {
                var type
                    = typeDic.name;

                gameType
                    = gameType
                    + type
                    + ",";
            }
        }
    }

    if (gameType.length > 0) 
    {
        gameType
            = gameType.substr(0, gameType.length - 1);
    }

    return gameType;
}

var kOnlineTags = ["多人", "竞技", "联机", "局域网"];
//是否是"线上"标签内游戏
GS.gameIsOnlineWithGameTags = function (tagArray) 
{
    var isOnline
        = false;

    if (tagArray != null
        && tagArray != undefined
        && tagArray.length > 0) 
    {
        for (var tagIndex = 0; tagIndex < kOnlineTags.length; tagIndex++) 
        {
            const tag = kOnlineTags[tagIndex];

            for (var objIndex = 0; objIndex < tagArray.length; objIndex++) 
            {
                const obj = tagArray[objIndex];

                if (obj != null
                    && obj != undefined
                    && obj.length > 0) 
                {
                    if (obj.indexOf(tag) != -1) 
                    {
                        isOnline
                            = true;
                        return isOnline;
                    }
                }
            }
        }
    }
    return isOnline;
}

GS.gameOnlineTagsIndex = function (gameTags) 
{
    for (var tagsIndex = 0; tagsIndex < gameTags.length; tagsIndex++) 
    {
        const tags = gameTags[tagsIndex];

        for (var objIndex = 0; objIndex < kOnlineTags.length; objIndex++) 
        {
            const obj = kOnlineTags[objIndex];

            if (tags != null
                && tags != undefined
                && tags.length > 0) 
            {
                if (tags.indexOf(obj) != -1) 
                {
                    return tagsIndex;
                }
            }
        }
    }
    return 0;
}

//添加游戏评分星级
GS.addScoreStarsElement = function (type, score) 
{
    var starNode
        = document.createElement("div");
    starNode.className = "ScoreStar" + " " + type;

    var width = 0;
    var height = 0;

    if (type == "Ratio") 
    {
        width = 84;
        height = 14.3;
        if (window.innerWidth < 375) 
        {
            width = 71.65;
            height = 12.2;
        }
    }
    else if (type == "InComment"
        || type == "InPlayed"
        || type == "InEvaluation")
    {
        width = 58;
        height = 10;
    }

    var grayStar
        = document.createElement("div");
    starNode.appendChild(grayStar);
    grayStar.className = "GrayStar" + " " + type;

    var redStar
        = document.createElement("div");
    starNode.appendChild(redStar);
    redStar.className = "RedStar" + " " + type;

    var starWidth = width * score / 10;
    redStar.style.clip = "rect(0 " + starWidth + "px" + " auto auto)";

    return starNode;
}


//友盟

GS.reportUMengStatistics = function (key)
{
    try
    {
        if (key.length < 1)
        {
            return;
        }

        // var msg = "GSApp://open.app?{\"contentType\":\"uMeng\", \"content\":\"" + key + "\", \"adId\":\"0\"}";
        var msg = "";
        if (gsIsCurrentOSAndroid())
        {
            msg = "GSApp://event.umeng.statistics.app?{\"event\": \"" + key + "\"}"
        }
        else
        {
            msg = "GSApp://event.umeng.statics.app?{\"event\": \"" + key + "\"}"
        }
        GS.sendMessage(msg);
    }
    catch (error)
    {
        console.log(error);
    }
}
