/**
 * Created by gamersky on 15/10/20.
 */
var GSApp_VideoParser = function ()
{ }
GSApp_VideoParser.video = null;
GSApp_VideoParser.getVideo = function ()
{
    if (GSApp_VideoParser.video != null)
    {
        return GSApp_VideoParser.video;
    }

    var video = null;
    var videos = document.getElementsByTagName("video");
    if (videos != null && videos.length > 0)
    {
        var videosCount = videos.length;
        for (var videoIndex = 0; videoIndex < videosCount; videoIndex++)
        {
            // !!! 只获取/操作第一个视频 !!!
            video = videos[videoIndex];
            if (video != null)
            {
                break;
            }
        }
    }
    GSApp_VideoParser.video = video;

    return video;
}
GSApp_VideoParser.isVideoValid = function ()
{
    var video = GSApp_VideoParser.getVideo();
    if (video == null)
    {
        return "no";
    }
    return "yes";
}
GSApp_VideoParser.getVideoPosterImageURL = function ()
{
    // 优酷
    try
    {
        var videoPosters = document.getElementsByClassName("x-video-poster");
        if (videoPosters != null
            && videoPosters.length > 0)
        {
            var videoPoster = videoPosters[0];
            var videoPosterImgs = videoPoster.getElementsByTagName("img");

            if (videoPosterImgs != null
                && videoPosterImgs.length > 0)
            {
                // @特殊处理
                GSApp_VideoParser.video = document.createElement("video");
                GSApp_VideoParser.video.src = "#优酷视频伪地址#";
                return videoPosterImgs[0].src;
            }
        }
    }
    catch (error)
    {
        console.log(error);
    }

    // B站
    try
    {
        var loadLayers = document.getElementsByClassName("load-layer");
        if (loadLayers != null
            && loadLayers.length > 0)
        {
            var loadLayer = loadLayers[0];
            var videoPosterImgs = loadLayer.getElementsByTagName("img");
            if (videoPosterImgs != null
                && videoPosterImgs.length > 0)
            {
                return videoPosterImgs[0].src;
            }
        }
    }
    catch (error)
    {
        console.log(error);
    }

    var video = GSApp_VideoParser.getVideo();
    if (video != null)
    {
        // 乐视
        var videoPoster = video.poster;
        if (videoPoster != null
            && videoPoster.length > 0)
        {
            return videoPoster;
        }

        // 优酷
        var imgs = document.getElementsByTagName("img");
        if (imgs != null
            && imgs.length > 0)
        {
            var img = imgs[0];
            {
            }
            return img.src;
        }

        // 土豆
        var posters = document.getElementsByClassName("poster");
        if (posters != null
            && posters.length > 0)
        {
            var poster = posters[0];
            {
            }
            return poster.style.backgroundImage;
        }
    }
    return null;
}
GSApp_VideoParser.getVideoSrc = function ()
{
    var video = GSApp_VideoParser.getVideo();
    if (video != null)
    {
        var videoSrc = video.src;
        if (!videoSrc
            || videoSrc.length < 1)
        {
            // B站：
            var videoSource = video.getElementsByTagName("source")[0];
            if (videoSource)
            {
                videoSrc = videoSource.getAttribute("src");
            }
        }

        if (videoSrc.length > 0)
        {
            video.pause();
            //
            if (videoSrc.indexOf("//") == 0)
            {
                videoSrc = "http:" + videoSrc;
            }
            //
            return videoSrc;
        }
        else
        {
            setTimeout(function ()
            {
                video.pause();
            },
                50);
        }
    }

    try
    {
        // 优酷：
        var playButton = document.getElementById("x-video-button");
        if (playButton != null)
        {
            var touchendEvent = document.createEvent('TouchEvent');
            {
                touchendEvent.initEvent('touchend', true, true);
            }
            playButton.dispatchEvent(touchendEvent);
        }
        // B站：
        else
        {
            var loadLayers = document.getElementsByClassName("load-layer");
            if (loadLayers != null
                && loadLayers.length > 0)
            {
                var loadLayer = loadLayers[0];
                var videoPosterImgs = loadLayer.getElementsByTagName("img");
                if (videoPosterImgs != null
                    && videoPosterImgs.length > 0)
                {
                    var playButton = videoPosterImgs[0];
                    if (playButton != null)
                    {
                        playButton.click();
                    }
                }
            }
        }
    }
    catch (e)
    { }

    return null;
}
GSApp_VideoParser.playVideo = function ()
{
    var video = GSApp_VideoParser.getVideo();
    if (video != null)
    {
        video.play();
    }
}
GSApp_VideoParser.pauseVideo = function ()
{
    var video = GSApp_VideoParser.getVideo();
    if (video != null)
    {
        video.pause();
    }
}
GSApp_VideoParser.isVideoPlaying = function ()
{
    var video = GSApp_VideoParser.getVideo();
    if (video != null)
    {
        if (!video.paused())
        {
            return "yes";
        }
    }
    return "no";
}
GSApp_VideoParser.getVideoInfoCallback = null;
GSApp_VideoParser.getVideoInfoTimerId = null;
GSApp_VideoParser.getVideoInfo = function (callback)
{
    GSApp_VideoParser.getVideoInfoCallback = callback;
    //
    var videoPosterURL = null;
    var videoSrc = null;
    try
    {
        videoPosterURL = GSApp_VideoParser.getVideoPosterImageURL();
        videoSrc = GSApp_VideoParser.getVideoSrc();
        // !!!
        clearTimeout(GSApp_VideoParser.getVideoInfoTimerId);
        // !!!
    }
    catch (error)
    {
        console.log(error);
    }
    //
    if (videoSrc
        && videoSrc.length > 0
        && videoPosterURL
        && videoPosterURL.length > 0)
    {
        if (GSApp_VideoParser.getVideoInfoCallback
            && GSApp_VideoParser.getVideoInfoCallback.length > 0)
        {
            var aTag = document.createElement("a");
            aTag.href = GSApp_VideoParser.getVideoInfoCallback + "?{\"videoSrc\":\"" + encodeURI(videoSrc) + "\",\"posterURL\":\"" + encodeURI(videoPosterURL) + "\"}";
            aTag.click();
        }
    }
    else
    {
        GSApp_VideoParser.getVideoInfoTimerId
            = setTimeout(function ()
            {
                GSApp_VideoParser.getVideoInfo(GSApp_VideoParser.getVideoInfoCallback);
            },
                50);
    }
}
// !!! 注意此处一定要换行，否则有语法错误 !!!
GSApp_VideoParser.getVideoInfo("GSApp://callback.parser.video.app");