////////////////////////////////////////////////
// @视频相关操作
////////////////////////////////////////////////

var GSApp_Video = function (videoId)
{
	return document.getElementById(GSApp_Video.createVideoId(videoId));
};

GSApp_Video.createVideoId = function (videoId)
{
	return "gsVideo_" + videoId;
};

// {
//     "id": "",
//     "posterURL": "",
//     "videoSrc": ""
// }
GSApp_Video.didVideoParsed = function (videoInfo)
{
	var videoContent = GSApp_Video.getVideoContentWithId(videoInfo.id);
	if (videoContent != null)
	{
		videoContent.videoSrc = videoInfo.videoSrc;
	}
	GSApp_Video.setThumbnailOfImageWithVideoId(videoInfo.id, videoInfo.posterURL);
};

GSApp_Video.setThumbnailOfImageWithVideoId = function (videoId, posterImgURL)
{
	try
	{
		var videoPlayerBox = document.getElementById(videoId);
		if (videoPlayerBox == null)
		{
			return;
		}

		if (posterImgURL.indexOf("url(") != 0)
		{
			posterImgURL = "url(" + posterImgURL + ")";
		}

		/*
		var videoPlayerBoxWidth = videoPlayerBox.clientWidth;
		var videoPlayerBoxHeight = videoPlayerBox.clientHeight;
		*/
		var videoPlayerBoxWidth
			= GSApp_MainBody.getContentAreaWidth();
		var videoPlayerBoxHeight
			= videoPlayerBoxWidth
			* 1080.0 / 1920.0;
		var videoPlayerBoxBackgroundSize
			= videoPlayerBoxWidth + "px " + videoPlayerBoxHeight + "px";


		videoPlayerBox.style.backgroundSize = videoPlayerBoxBackgroundSize;//"auto";
		videoPlayerBox.style.backgroundImage = posterImgURL;

		var videoPlayButtonBackgrounds
			= videoPlayerBox.getElementsByClassName("PlayButtonBackground");
		if (videoPlayButtonBackgrounds == null
			|| videoPlayButtonBackgrounds.length < 1)
		{
			return;
		}

		var videoPlayButtonBackgroundsCount = videoPlayButtonBackgrounds.length;
		for (var videoPlayButtonBackgroundIndex = 0;
			videoPlayButtonBackgroundIndex < videoPlayButtonBackgroundsCount;
			videoPlayButtonBackgroundIndex++)
		{
			var videoPlayButtonBackground = videoPlayButtonBackgrounds[videoPlayButtonBackgroundIndex];

			videoPlayButtonBackground.style.backgroundSize = videoPlayerBoxBackgroundSize;//"auto";
			// videoPlayButtonBackground.style.backgroundImage = posterImgURL;
		}
	}
	catch (error)
	{
		console.log(error);
	}
};

GSApp_Video.getYouKuVideoThumbnail = function (youKuVideoId)
{
	var requestURL
		= "https://api.youku.com/videos/show.json?client_id=6bfe5b183f11e7d9&video_id="
		+ youKuVideoId
		+ "&callback=jQuery18304995991599623619_1562981479832&_=1562981483683";

	gsPostToURL(requestURL, "GET", "", false, "GSApp_Video.didGetYouKuVideoThumbnail");
}

GSApp_Video.didGetYouKuVideoThumbnail = function (thumbnailResult)
{
	if (thumbnailResult != null
		&& thumbnailResult != undefined) 
	{
		var thumbnailJson
			= JSON.parse(decodeURIComponent(thumbnailResult));

		if (thumbnailJson != null
			&& thumbnailJson != undefined) 
		{
			if (gsIsCurrentOSIOS()) 
			{

			}
			else if (gsIsCurrentOSAndroid())
			{
				if (thumbnailJson.indexOf("jQuery") != -1) 
				{
					var startIdx = thumbnailJson.indexOf("({");
					var endIdx = thumbnailJson.indexOf("});");
					thumbnailJson
						= thumbnailJson.substring(startIdx + 1, thumbnailJson.length - endIdx);

					thumbnailJson
						= JSON.parse(decodeURIComponent(thumbnailJson));
				}
			}
			GSApp_Video.setThumbnailOfImageWithYouKuVideoId(thumbnailJson.id, thumbnailJson.bigThumbnail);
		}
	}
}

GSApp_Video.setThumbnailOfImageWithYouKuVideoId = function (youKuVideoId, posterImgURL)
{
	try
	{
		var videoPlayerBox = null;

		var videoNodes
			= document.getElementsByName(youKuVideoId);
		if (videoNodes != null
			&& videoNodes != undefined
			&& videoNodes.length > 0) 
		{
			for (var i = 0; i < videoNodes.length; i++) 
			{
				const videoNode = videoNodes[i];
				if (videoNode.getAttribute("name") == youKuVideoId) 
				{
					videoPlayerBox = videoNode;
					break;
				}
			}
		}

		if (videoPlayerBox != null
			&& videoPlayerBox != undefined) 
		{
			videoPlayerBox.style.backgroundImage = "url(" + posterImgURL + ")";
			videoPlayerBox.style.backgroundSize = "cover";
		}
	}
	catch (error)
	{
		console.log(error);
	}
};

GSApp_Video.playWithVideoId = function (videoId)
{
	try
	{
		var videoContent
			= GSApp_Video.getVideoContentWithId(videoId);
		if (!videoContent)
		{
			return;
		}
		var videoPlayerBox
			= document.getElementById(videoId);
		if (videoPlayerBox == null)
		{
			return;
		}

		var videoSrc
			= videoContent.videoSrc;
		if (!videoSrc)
		{
			videoSrc = "";
		}
		var videoYouKuVideoId
			= videoContent.youkuVideoId;
		if (!videoYouKuVideoId)
		{
			videoYouKuVideoId = "";
		}

		var msg
			= "GSApp://play.video.app?{"
			+ "\"id\":\"" + videoId + "\""
			+ ", \"videoSrc\":\"" + videoSrc + "\""
			+ ", \"youKuVideoId\":\"" + videoYouKuVideoId + "\""
			+ ", \"frame\":["
			+ videoPlayerBox.offsetLeft
			+ ", " + videoPlayerBox.offsetTop
			+ ", " + videoPlayerBox.scrollWidth
			+ ", " + videoPlayerBox.scrollHeight
			+ "]}";

		GSApp.sendMessage(msg);
	}
	catch (error)
	{
		console.log(error);
	}
};

GSApp_Video.createLeTvVideoHTML = function (videoId, videoParam)
{
	var bodyWidth = document.body.clientWidth - 24.0;
	var height = bodyWidth * 9.0 / 16.0;
	var width = bodyWidth;
	var leTv_videosupport_js = "http:\/\/j.gamersky.com\/wap\/js\/leTv_videosupport_2.0_v1.m.js";

	var html
		= "<div id=\"leshitvauto\" style=\"margin-left:auto;margin-right:auto; width:" + width + "; height:" + height + ";\">"

		+ "<script type=\"text\/javascript\">"

		+ "var domainname = \"http:\/\/yuntv.letv.com\/\";"

		+ "<\/script>"
		+ "<script type=\"text\/javascript\" src=\"http:\/\/yuntv.letv.com\/swfobj_1.3.m.js\"><\/script>"

		+ "<script type=\"text\/javascript\" src=\"" + leTv_videosupport_js + "\"><\/script>"

		+ "<script type=\"text\/javascript\" src=\"http:\/\/yuntv.letv.com\/user_defined.js?v2\"><\/script>"

		+ "<script type=\"text\/javascript\" src=\"http:\/\/yuntv.letv.com\/js\/player_v2.3.js\" data=\"{uu:'" + videoId + "',vu:'" + videoParam + "',auto_play:'0',gpcflag:'1',width:'" + width + "',height:'" + height + "'}\"><\/script>"

		+ "<\/div>";

	return html;
};

/*视频相关方法*/
// 优酷视频Id结束符号
GSApp_Video.kYouKuVideoIdEndSign = "==";
GSApp_Video.getYouKuVideoIdWithContentURL = function (videoContent)
{
	// 尝试获取优酷视频Id.
	var youkuVideoId = null;
	if (videoContent != null
		&& videoContent.length > -1)
	{
		// 去除空格.
		videoContent = videoContent.replace(new RegExp(" ", "gm"), "");
		// 保存原始视频内容.
		var originVideoContent = videoContent;
		// 小写化.
		videoContent = videoContent.toLowerCase();

		// 尝试从URL格式的视频代码中获取视频Id.
		var urlPlayerSign
			= "://v.youku.com/v_show/id_";// "http://v.youku.com/v_show/id_"
		var indexOfURLPlayerSign
			= videoContent.indexOf(urlPlayerSign);


		if (indexOfURLPlayerSign > -1)
		{
			var youkuVideoIdBeginCharIndex
				= indexOfURLPlayerSign + urlPlayerSign.length;
			var youkuVideoIdEndCharIndex
				= videoContent.indexOf(
					GSApp_Video.kYouKuVideoIdEndSign,
					youkuVideoIdBeginCharIndex);
			if (youkuVideoIdEndCharIndex >= 0)
			{
				youkuVideoIdEndCharIndex
					= youkuVideoIdEndCharIndex
					+ GSApp_Video.kYouKuVideoIdEndSign.length;
			}
			else
			{
				youkuVideoIdEndCharIndex
					= videoContent.indexOf(
						".",
						youkuVideoIdBeginCharIndex);
				if (youkuVideoIdEndCharIndex < 0)
				{
					youkuVideoIdEndCharIndex
						= videoContent.length;
				}
			}
			youkuVideoId
				= originVideoContent.substring(
					youkuVideoIdBeginCharIndex,
					youkuVideoIdEndCharIndex);
		}
		else
		{
			// 尝试从iFrame格式的视频代码中获取视频Id.
			var iFramePlayerSign
				= "://player.youku.com/embed/";// "http://player.youku.com/embed/";
			var indexOfiFramePlayerSign
				= videoContent.indexOf(iFramePlayerSign);
			if (indexOfiFramePlayerSign > -1)
			{
				var youkuVideoIdBeginCharIndex
					= indexOfiFramePlayerSign + iFramePlayerSign.length;
				var youkuVideoIdEndCharIndex
					= videoContent.indexOf(
						GSApp_Video.kYouKuVideoIdEndSign,
						youkuVideoIdBeginCharIndex);
				if (youkuVideoIdEndCharIndex != -1)
				{
					youkuVideoIdEndCharIndex
						+= GSApp_Video.kYouKuVideoIdEndSign.length;
				}
				else
				{
					youkuVideoIdEndCharIndex
						= originVideoContent.length;
				}
				youkuVideoId
					= originVideoContent.substring(youkuVideoIdBeginCharIndex, youkuVideoIdEndCharIndex);
			}
			else
			{
				// 尝试从JS格式的视频代码中获取视频Id.
				var jsPlayerSign
					= "vid:'";
				var indexOfJSPlayerSign
					= videoContent.indexOf(jsPlayerSign);
				if (indexOfJSPlayerSign > -1)
				{
					var youkuVideoIdBeginCharIndex
						= indexOfJSPlayerSign + jsPlayerSign.length;
					var youkuVideoIdEndCharIndex
						= videoContent.indexOf(
							GSApp_Video.kYouKuVideoIdEndSign,
							youkuVideoIdBeginCharIndex)
						+ GSApp_Video.kYouKuVideoIdEndSign.length;
					youkuVideoId
						= originVideoContent.substring(youkuVideoIdBeginCharIndex,
							youkuVideoIdEndCharIndex);
				}
			}
		}
	}
	return youkuVideoId;
};

GSApp_Video.videoObjects = new Array();

GSApp_Video.addVideoContent = function (videoOriginContent, isVideoOriginContentVideoSrc)
{
	if (videoOriginContent == null)
	{
		videoOriginContent = "";
	}
	else
	{
		videoOriginContent = videoOriginContent.trim();
	}
	videoOriginContent = videoOriginContent.trim();

	////////////////////////////////////////////////
	// 过滤调整 videoOriginContent
	////////////////////////////////////////////////
	var videoURL = videoOriginContent;
	var videoSrc = "";
	var youkuVideoId = "";
	if (isVideoOriginContentVideoSrc)
	{
		videoSrc = videoOriginContent;
	}
	else
	{
		var indexOfIFrameTagBeginCharIndex = videoOriginContent.indexOfWithIgnorecase("<iframe");
		if (indexOfIFrameTagBeginCharIndex == 0)
		{
			var indexOfIFrameTagEndCharIndex = videoOriginContent.indexOf(">");
			if (indexOfIFrameTagEndCharIndex > -1)
			{
				var iFrameTag = videoOriginContent.substring(indexOfIFrameTagBeginCharIndex,
					indexOfIFrameTagEndCharIndex + 1);
				if (iFrameTag != null && iFrameTag.length > 0)
				{
					var srcBegin = "src=\"";
					var indexOfSrcBeginCharIndex
						= iFrameTag.indexOfWithIgnorecase(srcBegin);
					if (indexOfSrcBeginCharIndex < 0)
					{
						srcBegin = "src=\'";
						indexOfSrcBeginCharIndex
							= iFrameTag.indexOfWithIgnorecase(srcBegin);
					}
					if (indexOfSrcBeginCharIndex > 0)
					{
						iFrameTag = iFrameTag.substring(indexOfSrcBeginCharIndex + srcBegin.length);
						indexOfSrcBeginCharIndex = 0;

						var srcEndSign = srcBegin.charAt(srcBegin.length - 1);

						var indexOfSrcEndCharIndex = iFrameTag.indexOf(srcEndSign);
						if (indexOfSrcEndCharIndex > 0)
						{
							var iFrameTagLength = iFrameTag.length;
							while (indexOfSrcEndCharIndex > 0
								&& indexOfSrcEndCharIndex < iFrameTagLength
								&& iFrameTag.charAt(indexOfSrcEndCharIndex - 1) == "\\")
							{
								indexOfSrcEndCharIndex = iFrameTag.indexOf(srcEndSign, indexOfSrcEndCharIndex + 1);
							}
						}
						if (indexOfSrcEndCharIndex < 0)
						{
							indexOfSrcEndCharIndex = iFrameTag.length;
						}

						iFrameTag = iFrameTag.substring(indexOfSrcBeginCharIndex,
							indexOfSrcEndCharIndex - indexOfSrcBeginCharIndex);
						////////////////////////////////////////////////
						// 调整后的 videoOriginContent
						////////////////////////////////////////////////
						// !!!
						videoURL = iFrameTag;
						// !!!
					}
				}
			}
		}
		else if (videoOriginContent.indexOfWithIgnorecase("bdstatic.com") >= 0)
		{
			var videoSrcBeginSign = "src=\"";
			var videoSrcBeginSignBeginIndex = videoOriginContent.indexOfWithIgnorecase(videoSrcBeginSign);
			if (videoSrcBeginSignBeginIndex >= 0)
			{
				var videoSrcBeginIndex
					= videoSrcBeginSignBeginIndex + videoSrcBeginSign.length;
				var videoSrcEndIndex
					= videoOriginContent.indexOf("\"", videoSrcBeginIndex);
				if (videoSrcEndIndex > videoSrcBeginIndex)
				{
					videoURL = videoOriginContent.substring(videoSrcBeginIndex, videoSrcEndIndex);
				}
			}
		}
		// !!!
		youkuVideoId = GSApp_Video.getYouKuVideoIdWithContentURL(videoURL);
		// !!!
	}


	////////////////////////////////////////////////
	// 加入 kGSVideoOriginContents
	////////////////////////////////////////////////
	if (GSApp_Video.videoObjects == null)
	{
		GSApp_Video.videoObjects = new Array();
	}
	var videoObject = new Object();
	{
		videoObject.id = GSApp_Video.createVideoId(GSApp_Video.videoObjects.length);
		videoObject.videoSrc = videoSrc;
		videoObject.videoOriginURL = videoURL;
		videoObject.youkuVideoId = youkuVideoId;
		videoObject.play = function ()
		{
			GSApp_Video.playWithVideoId(videoObject.id);
		};
	}
	GSApp_Video.videoObjects.push(videoObject);

	return videoObject;
}

GSApp_Video.getVideoContentWithId = function (videoContentId)
{
	if (videoContentId
		&& videoContentId.length > 0)
	{
		for (var i = GSApp_Video.videoObjects.length - 1;
			i > -1;
			i--)
		{
			var videoContent = GSApp_Video.videoObjects[i];
			if (videoContent.id == videoContentId)
			{
				return videoContent;
			}
		}
	}
	return null;
};

